#ifndef LIB_DBG_DEBUG_MQLAPI_MQL45_TRACER_MQH_INCLUDED
#define LIB_DBG_DEBUG_MQLAPI_MQL45_TRACER_MQH_INCLUDED
#property version "5.50"
/**********************************************************************************
 * Copyright (C) 2020 Dominik Egert <info@freie-netze.de>
 *
 * This file is the MQL-API MQL4+ and 5 rewrite functions include file.
 *
 * Lisence applied: GPLv2
 *                  https://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 *
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 4120
 *  State: public
 *
 *  File information
 *  ================
 *
*/




//*********************************************************************************************************************************************************/
//  BEGIN MQLAPI tracer
//



/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// MQL5 API function call meta object
//

#ifndef __MQL4__
    namespace dbg_lib
    {

#endif


    template <typename EXT_OBJ>
    class LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object_mql45) : public LIB_DBG_NAMESPACE_DEF(dbg_lib, mqlapi_call_tracer_object_vararg)<EXT_OBJ>
    {
        public:
            // MQL-API rewrite functions with return values

            double dbg_mqlapi_trace_func_AccountInfoDouble(ENUM_ACCOUNT_INFO_DOUBLE property_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::AccountInfoDouble(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_AccountInfoInteger(ENUM_ACCOUNT_INFO_INTEGER property_id)
            {
                switch(property_id)
                {
                    case ACCOUNT_TRADE_MODE:        return(__AccountInfoInteger_ENUM_ACCOUNT_TRADE_MODE(property_id));
                    case ACCOUNT_MARGIN_SO_MODE:    return(__AccountInfoInteger_ENUM_ACCOUNT_STOPOUT_MODE(property_id));
                #ifndef __MQL4__
                    case ACCOUNT_MARGIN_MODE:       return(__AccountInfoInteger_ENUM_ACCOUNT_MARGIN_MODE(property_id));

                #endif
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::AccountInfoInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long __AccountInfoInteger_ENUM_ACCOUNT_TRADE_MODE(ENUM_ACCOUNT_INFO_INTEGER property_id)
            {
                ENUM_ACCOUNT_TRADE_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ACCOUNT_TRADE_MODE)::AccountInfoInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            long __AccountInfoInteger_ENUM_ACCOUNT_STOPOUT_MODE(ENUM_ACCOUNT_INFO_INTEGER property_id)
            {
                ENUM_ACCOUNT_STOPOUT_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ACCOUNT_STOPOUT_MODE)::AccountInfoInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
        #ifndef __MQL4__
            long __AccountInfoInteger_ENUM_ACCOUNT_MARGIN_MODE(ENUM_ACCOUNT_INFO_INTEGER property_id)
            {
                ENUM_ACCOUNT_MARGIN_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ACCOUNT_MARGIN_MODE)::AccountInfoInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };

        #endif
            string dbg_mqlapi_trace_func_AccountInfoString(ENUM_ACCOUNT_INFO_STRING property_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::AccountInfoString(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_acos(double val)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, val, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::acos(val);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayBsearch(const T& array[], T value)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayBsearch(array, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayBsearch(const T& array[][], T value)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayBsearch(array, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayBsearch(const T& array[][][], T value)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayBsearch(array, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayBsearch(const T& array[][][][], T value)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayBsearch(array, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayCompare(const T& array1[], const T& array2[], int start1 = 0, int start2 = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, array1, array2, start1, start2, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayCompare(array1, array2, start1, start2, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayCompare(const T& array1[][], const T& array2[][], int start1 = 0, int start2 = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, array1, array2, start1, start2, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayCompare(array1, array2, start1, start2, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayCompare(const T& array1[][][], const T& array2[][][], int start1 = 0, int start2 = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, array1, array2, start1, start2, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayCompare(array1, array2, start1, start2, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayCompare(const T& array1[][][][], const T& array2[][][][], int start1 = 0, int start2 = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, array1, array2, start1, start2, count, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayCompare(array1, array2, start1, start2, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T, typename U> int dbg_mqlapi_trace_func_ArrayCopy(T& dst_array[], const U& src_array[], int dst_start = 0, int src_start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, src_array, dst_start, src_start, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayCopy(dst_array, src_array, dst_start, src_start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dst_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T, typename U> int dbg_mqlapi_trace_func_ArrayCopy(T& dst_array[][], const U& src_array[][], int dst_start = 0, int src_start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, src_array, dst_start, src_start, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayCopy(dst_array, src_array, dst_start, src_start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dst_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T, typename U> int dbg_mqlapi_trace_func_ArrayCopy(T& dst_array[][][], const U& src_array[][][], int dst_start = 0, int src_start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, src_array, dst_start, src_start, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayCopy(dst_array, src_array, dst_start, src_start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dst_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T, typename U> int dbg_mqlapi_trace_func_ArrayCopy(T& dst_array[][][][], const U& src_array[][][][], int dst_start = 0, int src_start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, src_array, dst_start, src_start, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayCopy(dst_array, src_array, dst_start, src_start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dst_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayGetAsSeries(const T& array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayGetAsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayGetAsSeries(const T& array[][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayGetAsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayGetAsSeries(const T& array[][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayGetAsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayGetAsSeries(const T& array[][][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayGetAsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayGetAsSeries(T*& array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayGetAsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayGetAsSeries(T*& array[][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayGetAsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayGetAsSeries(T*& array[][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayGetAsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayGetAsSeries(T*& array[][][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayGetAsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T, typename U> int dbg_mqlapi_trace_func_ArrayInitialize(T& array[], U value)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayInitialize(array, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T, typename U> int dbg_mqlapi_trace_func_ArrayInitialize(T& array[][], U value)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayInitialize(array, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T, typename U> int dbg_mqlapi_trace_func_ArrayInitialize(T& array[][][], U value)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayInitialize(array, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T, typename U> int dbg_mqlapi_trace_func_ArrayInitialize(T& array[][][][], U value)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayInitialize(array, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsDynamic(const T& array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsDynamic(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsDynamic(const T& array[][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsDynamic(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsDynamic(const T& array[][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsDynamic(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsDynamic(const T& array[][][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsDynamic(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsDynamic(T*& array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsDynamic(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsDynamic(T*& array[][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsDynamic(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsDynamic(T*& array[][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsDynamic(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsDynamic(T*& array[][][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsDynamic(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsSeries(const T& array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsSeries(const T& array[][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsSeries(const T& array[][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsSeries(const T& array[][][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsSeries(T*& array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsSeries(T*& array[][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsSeries(T*& array[][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArrayIsSeries(T*& array[][][][])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayIsSeries(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayMaximum(const T& array[], int start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayMaximum(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayMaximum(const T& array[][], int start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayMaximum(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayMaximum(const T& array[][][], int start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayMaximum(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayMaximum(const T& array[][][][], int start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayMaximum(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayMinimum(const T& array[], int start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayMinimum(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayMinimum(const T& array[][], int start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayMinimum(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayMinimum(const T& array[][][], int start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayMinimum(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayMinimum(const T& array[][][][], int start = 0, int count = WHOLE_ARRAY)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayMinimum(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayRange(const T& array[], int rank_index)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, rank_index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRange(array, rank_index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayRange(const T& array[][], int rank_index)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, rank_index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRange(array, rank_index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayRange(const T& array[][][], int rank_index)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, rank_index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRange(array, rank_index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayRange(const T& array[][][][], int rank_index)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, rank_index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRange(array, rank_index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayRange(T*& array[], int rank_index)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, rank_index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRange(array, rank_index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayRange(T*& array[][], int rank_index)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, rank_index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRange(array, rank_index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayRange(T*& array[][][], int rank_index)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, rank_index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRange(array, rank_index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayRange(T*& array[][][][], int rank_index)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, rank_index, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayRange(array, rank_index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayResize(T& array[], int new_size, int reserve_size = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, new_size, reserve_size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayResize(array, new_size, reserve_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayResize(T& array[][], int new_size, int reserve_size = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, new_size, reserve_size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayResize(array, new_size, reserve_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayResize(T& array[][][], int new_size, int reserve_size = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, new_size, reserve_size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayResize(array, new_size, reserve_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayResize(T& array[][][][], int new_size, int reserve_size = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, new_size, reserve_size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayResize(array, new_size, reserve_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayResize(T*& array[], int new_size, int reserve_size = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, new_size, reserve_size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayResize(array, new_size, reserve_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayResize(T*& array[][], int new_size, int reserve_size = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, new_size, reserve_size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayResize(array, new_size, reserve_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayResize(T*& array[][][], int new_size, int reserve_size = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, new_size, reserve_size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayResize(array, new_size, reserve_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArrayResize(T*& array[][][][], int new_size, int reserve_size = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, new_size, reserve_size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArrayResize(array, new_size, reserve_size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArraySetAsSeries(const T& array[], bool flag)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, flag, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySetAsSeries(array, flag);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> bool dbg_mqlapi_trace_func_ArraySetAsSeries(T*& array[], bool flag)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, array, flag, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySetAsSeries(array, flag);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArraySize(const T& array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySize(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArraySize(const T& array[][])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySize(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArraySize(const T& array[][][])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySize(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArraySize(const T& array[][][][])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySize(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArraySize(T*& array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySize(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArraySize(T*& array[][])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySize(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArraySize(T*& array[][][])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySize(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> int dbg_mqlapi_trace_func_ArraySize(T*& array[][][][])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ArraySize(array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> ENUM_POINTER_TYPE dbg_mqlapi_trace_func_CheckPointer(T* anyobject)
            {
                ENUM_POINTER_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, anyobject, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CheckPointer(anyobject);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_CharArrayToString(const uchar& array[], int start = 0, int count = -1, uint codepage = CP_ACP)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                string cp_name = NULL;
                switch(codepage)
                {
                    case CP_ACP:        cp_name = "CP_ACP";         break;
                    case CP_OEMCP:      cp_name = "CP_OEMCP";       break;
                    case CP_MACCP:      cp_name = "CP_MACCP";       break;
                    case CP_THREAD_ACP: cp_name = "CP_THREAD_ACP";  break;
                    case CP_SYMBOL:     cp_name = "CP_SYMBOL";      break;
                    case CP_UTF7:       cp_name = "CP_UTF7";        break;
                    case CP_UTF8:       cp_name = "CP_UTF8";        break;
                }
                if(cp_name == NULL)
                { DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, array, start, count, codepage, 0, 0, 0); }
                else
                { DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, array, start, count, codepage, cp_name, 0, 0); }
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CharArrayToString(array, start, count, codepage);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartApplyTemplate(long chart_id, const string filename)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, chart_id, filename, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartApplyTemplate(chart_id, filename);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartClose(long chart_id = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, chart_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartClose(chart_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ChartFirst()
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartFirst();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_ChartGetDouble(long chart_id, ENUM_CHART_PROPERTY_DOUBLE prop_id, int sub_window = 0)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, sub_window, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartGetDouble(chart_id, prop_id, sub_window);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ChartGetInteger(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, int sub_window = 0)
            {
                switch(prop_id)
                {
                    case CHART_MODE:                return(dbg_mqlapi_trace_func_ChartGetInteger_ENUM_CHART_MODE(chart_id, prop_id, sub_window));
                    case CHART_SHOW_VOLUMES:        return(dbg_mqlapi_trace_func_ChartGetInteger_ENUM_CHART_VOLUME_MODE(chart_id, prop_id, sub_window));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, sub_window, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartGetInteger(chart_id, prop_id, sub_window);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartGetInteger(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, int sub_window, long& long_var)
            {
                switch(prop_id)
                {
                    case CHART_MODE:                return(dbg_mqlapi_trace_func_ChartGetInteger_ENUM_CHART_MODE(chart_id, prop_id, sub_window, long_var));
                    case CHART_SHOW_VOLUMES:        return(dbg_mqlapi_trace_func_ChartGetInteger_ENUM_CHART_VOLUME_MODE(chart_id, prop_id, sub_window, long_var));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, sub_window, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartGetInteger(chart_id, prop_id, sub_window, long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ChartGetInteger_ENUM_CHART_MODE(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, int sub_window = 0)
            {
                ENUM_CHART_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, sub_window, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_CHART_MODE)::ChartGetInteger(chart_id, prop_id, sub_window);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ChartGetInteger_ENUM_CHART_MODE(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, int sub_window, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, sub_window, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartGetInteger(chart_id, prop_id, sub_window, _long_var);
                ENUM_CHART_MODE long_var = (ENUM_CHART_MODE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ChartGetInteger_ENUM_CHART_VOLUME_MODE(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, int sub_window = 0)
            {
                ENUM_CHART_VOLUME_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, sub_window, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_CHART_VOLUME_MODE)::ChartGetInteger(chart_id, prop_id, sub_window);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ChartGetInteger_ENUM_CHART_VOLUME_MODE(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, int sub_window, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, sub_window, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartGetInteger(chart_id, prop_id, sub_window, _long_var);
                ENUM_CHART_VOLUME_MODE long_var = (ENUM_CHART_VOLUME_MODE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ChartGetString(long chart_id, ENUM_CHART_PROPERTY_STRING prop_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, chart_id, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartGetString(chart_id, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartGetString(long chart_id, ENUM_CHART_PROPERTY_STRING prop_id, string& string_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, chart_id, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartGetString(chart_id, prop_id, string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ChartID()
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartID();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartIndicatorDelete(long chart_id, int sub_window, const string indicator_shortname)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, sub_window, indicator_shortname, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartIndicatorDelete(chart_id, sub_window, indicator_shortname);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ChartIndicatorName(long chart_id, int sub_window, int index)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, sub_window, index, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartIndicatorName(chart_id, sub_window, index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ChartIndicatorsTotal(long chart_id, int sub_window)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, chart_id, sub_window, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartIndicatorsTotal(chart_id, sub_window);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartNavigate(long chart_id, ENUM_CHART_POSITION position, int shift = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, position, shift, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartNavigate(chart_id, position, shift);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ChartNext(long chart_id)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, chart_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartNext(chart_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ChartOpen(string symbol, ENUM_TIMEFRAMES period)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, symbol, period, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartOpen(symbol, period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_CharToString(uchar char_code)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, char_code, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CharToString(char_code);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ENUM_TIMEFRAMES dbg_mqlapi_trace_func_ChartPeriod(long chart_id = 0)
            {
                ENUM_TIMEFRAMES retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, chart_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartPeriod(chart_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_ChartPriceOnDropped()
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartPriceOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartSaveTemplate(long chart_id, const string filename)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, chart_id, filename, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSaveTemplate(chart_id, filename);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartScreenShot(long chart_id, string filename, int width, int height, ENUM_ALIGN_MODE align_mode = ALIGN_RIGHT)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, filename, width, height, align_mode, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartScreenShot(chart_id, filename, width, height, align_mode);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartSetDouble(long chart_id, ENUM_CHART_PROPERTY_DOUBLE prop_id, double value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSetDouble(chart_id, prop_id, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartSetInteger(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, long value)
            {
                switch(prop_id)
                {
                    case CHART_MODE:                return(dbg_mqlapi_trace_func_ChartSetInteger_ENUM_CHART_MODE(chart_id, prop_id, (ENUM_CHART_MODE)value));
                    case CHART_SHOW_VOLUMES:        return(dbg_mqlapi_trace_func_ChartSetInteger_ENUM_CHART_VOLUME_MODE(chart_id, prop_id, (ENUM_CHART_VOLUME_MODE)value));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSetInteger(chart_id, prop_id, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartSetInteger(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, int sub_window, long value)
            {
                switch(prop_id)
                {
                    case CHART_MODE:                return(dbg_mqlapi_trace_func_ChartSetInteger_ENUM_CHART_MODE(chart_id, prop_id, sub_window, (ENUM_CHART_MODE)value));
                    case CHART_SHOW_VOLUMES:        return(dbg_mqlapi_trace_func_ChartSetInteger_ENUM_CHART_VOLUME_MODE(chart_id, prop_id, sub_window, (ENUM_CHART_VOLUME_MODE)value));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, prop_id, sub_window, value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSetInteger(chart_id, prop_id, sub_window, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

            bool dbg_mqlapi_trace_func_ChartSetInteger_ENUM_CHART_MODE(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, ENUM_CHART_MODE value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSetInteger(chart_id, prop_id, (long)value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartSetInteger_ENUM_CHART_MODE(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, int sub_window, ENUM_CHART_MODE value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, prop_id, sub_window, value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSetInteger(chart_id, prop_id, sub_window, (long)value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartSetInteger_ENUM_CHART_VOLUME_MODE(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, ENUM_CHART_VOLUME_MODE value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSetInteger(chart_id, prop_id, (long)value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartSetInteger_ENUM_CHART_VOLUME_MODE(long chart_id, ENUM_CHART_PROPERTY_INTEGER prop_id, int sub_window, ENUM_CHART_VOLUME_MODE value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, prop_id, sub_window, value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSetInteger(chart_id, prop_id, sub_window, (long)value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartSetString(long chart_id, ENUM_CHART_PROPERTY_STRING prop_id, string str_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, prop_id, str_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSetString(chart_id, prop_id, str_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartSetSymbolPeriod(long chart_id, string symbol, ENUM_TIMEFRAMES period)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, symbol, period, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSetSymbolPeriod(chart_id, symbol, period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ChartSymbol(long chart_id = 0)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, chart_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartSymbol(chart_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_ChartTimeOnDropped()
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartTimeOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartTimePriceToXY(long chart_id, int sub_window, datetime time, double price, int& x, int& y)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, sub_window, time, price, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartTimePriceToXY(chart_id, sub_window, time, price, x, y);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, x, y, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ChartWindowFind(long chart_id, string indicator_shortname)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, chart_id, indicator_shortname, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartWindowFind(chart_id, indicator_shortname);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ChartWindowOnDropped()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartWindowOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ChartXOnDropped()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartXOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ChartXYToTimePrice(long chart_id, int x, int y, int& sub_window, datetime& time, double& price)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, x, y, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartXYToTimePrice(chart_id, x, y, sub_window, time, price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(3, sub_window, time, price, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ChartYOnDropped()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ChartYOnDropped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_ColorToARGB(color clr, uchar alpha = 255)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, clr, alpha, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ColorToARGB(clr, alpha);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ColorToString(color color_value, bool color_name)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, color_value, color_name, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ColorToString(color_value, color_name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyClose(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, double& close_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyClose(symbol_name, timeframe, start_pos, count, close_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, close_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyClose(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, int count, double& close_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyClose(symbol_name, timeframe, start_time, count, close_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, close_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyClose(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time, double& close_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyClose(symbol_name, timeframe, start_time, stop_time, close_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, close_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyHigh(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, double& high_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyHigh(symbol_name, timeframe, start_pos, count, high_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, high_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyHigh(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, int count, double& high_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyHigh(symbol_name, timeframe, start_time, count, high_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, high_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyHigh(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time, double& high_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyHigh(symbol_name, timeframe, start_time, stop_time, high_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, high_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyLow(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, double& low_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyLow(symbol_name, timeframe, start_pos, count, low_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, low_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyLow(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, int count, double& low_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyLow(symbol_name, timeframe, start_time, count, low_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, low_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyLow(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time, double& low_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyLow(symbol_name, timeframe, start_time, stop_time, low_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, low_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyOpen(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, double& open_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyOpen(symbol_name, timeframe, start_pos, count, open_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, open_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyOpen(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, int count, double& open_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyOpen(symbol_name, timeframe, start_time, count, open_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, open_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyOpen(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time, double& open_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyOpen(symbol_name, timeframe, start_time, stop_time, open_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, open_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CopyRates(string symbol, ENUM_TIMEFRAMES timeframe, int start_pos, int count, MqlRates& rates_array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, timeframe, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyRates(symbol, timeframe, start_pos, count, rates_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, rates_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CopyRates(string symbol, ENUM_TIMEFRAMES timeframe, datetime start_time, int count, MqlRates& rates_array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, timeframe, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyRates(symbol, timeframe, start_time, count, rates_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, rates_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_CopyRates(string symbol, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time, MqlRates& rates_array[])
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyRates(symbol, timeframe, start_time, stop_time, rates_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, rates_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyRealVolume(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, long& volume_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyRealVolume(symbol_name, timeframe, start_pos, count, volume_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, volume_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyRealVolume(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, int count, long& volume_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyRealVolume(symbol_name, timeframe, start_time, count, volume_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, volume_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyRealVolume(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time, long& volume_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyRealVolume(symbol_name, timeframe, start_time, stop_time, volume_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, volume_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopySpread(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, int& spread_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySpread(symbol_name, timeframe, start_pos, count, spread_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, spread_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopySpread(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, int count, int& spread_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySpread(symbol_name, timeframe, start_time, count, spread_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, spread_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopySpread(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time, int& spread_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopySpread(symbol_name, timeframe, start_time, stop_time, spread_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, spread_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyTickVolume(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, long& volume_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyTickVolume(symbol_name, timeframe, start_pos, count, volume_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, volume_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyTickVolume(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, int count, long& volume_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyTickVolume(symbol_name, timeframe, start_time, count, volume_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, volume_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyTickVolume(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time, long& volume_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyTickVolume(symbol_name, timeframe, start_time, stop_time, volume_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, volume_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyTime(string symbol_name, ENUM_TIMEFRAMES timeframe, int start_pos, int count, datetime& time_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_pos, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyTime(symbol_name, timeframe, start_pos, count, time_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, time_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyTime(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, int count, datetime& time_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyTime(symbol_name, timeframe, start_time, count, time_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, time_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CopyTime(string symbol_name, ENUM_TIMEFRAMES timeframe, datetime start_time, datetime stop_time, datetime& time_array[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, symbol_name, timeframe, start_time, stop_time, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CopyTime(symbol_name, timeframe, start_time, stop_time, time_array);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, time_array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CryptDecode(ENUM_CRYPT_METHOD method, const uchar& data[], const uchar& key[], uchar& result[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, method, data, key, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CryptDecode(method, data, key, result);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, result, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_CryptEncode(ENUM_CRYPT_METHOD method, const uchar& data[], const uchar& key[], uchar& result[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, method, data, key, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::CryptEncode(method, data, key, result);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, result, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_Digits()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::Digits();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_DoubleToString(double value, int digits = 8)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, value, digits, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::DoubleToString(value, digits);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> string dbg_mqlapi_trace_func_EnumToString(T value)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::EnumToString(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_EventChartCustom(long chart_id, ushort custom_event_id, long lparam, double dparam, string sparam)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, custom_event_id, lparam, dparam, sparam, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::EventChartCustom(chart_id, custom_event_id, lparam, dparam, sparam);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_EventSetMillisecondTimer(int milliseconds)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, milliseconds, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::EventSetMillisecondTimer(milliseconds);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_EventSetTimer(int seconds)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, seconds, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::EventSetTimer(seconds);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FileCopy(const string src_file_name, int common_flag, const string dst_file_name, int mode_flags)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _FILE_COMMON         = ((common_flag & FILE_COMMON) != NULL);
                const bool _FILE_READ           = ((mode_flags & FILE_READ) != NULL);
                const bool _FILE_WRITE          = ((mode_flags & FILE_WRITE) != NULL);
                const bool _FILE_BIN            = ((mode_flags & FILE_BIN) != NULL);
                const bool _FILE_CSV            = ((mode_flags & FILE_CSV) != NULL);
                const bool _FILE_TXT            = ((mode_flags & FILE_TXT) != NULL);
                const bool _FILE_ANSI           = ((mode_flags & FILE_ANSI) != NULL);
                const bool _FILE_UNICODE        = ((mode_flags & FILE_UNICODE) != NULL);
                const bool _FILE_SHARE_READ     = ((mode_flags & FILE_SHARE_READ) != NULL);
                const bool _FILE_SHARE_WRITE    = ((mode_flags & FILE_SHARE_WRITE) != NULL);
                const bool _FILE_REWRITE        = ((mode_flags & FILE_REWRITE) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, _FILE_REWRITE, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, _FILE_BIN, _FILE_CSV, _FILE_TXT, _FILE_ANSI, _FILE_UNICODE, _FILE_SHARE_READ, _FILE_SHARE_WRITE);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, src_file_name, common_flag, dst_file_name, mode_flags, _FILE_COMMON, _FILE_READ, _FILE_WRITE);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileCopy(src_file_name, common_flag, dst_file_name, mode_flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FileDelete(const string file_name, int common_flag = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _FILE_COMMON         = ((common_flag & FILE_COMMON) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_name, common_flag, _FILE_COMMON, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileDelete(file_name, common_flag);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_FileFindFirst(const string file_filter, string& returned_filename, int common_flag = 0)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _FILE_COMMON         = ((common_flag & FILE_COMMON) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_filter, common_flag, _FILE_COMMON, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileFindFirst(file_filter, returned_filename, common_flag);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, returned_filename, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FileFindNext(long search_handle, string& returned_filename)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, search_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileFindNext(search_handle, returned_filename);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, returned_filename, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_FileGetInteger(int file_handle, ENUM_FILE_PROPERTY_INTEGER property_id)
            {
                switch(property_id)
                {
                    case FILE_CREATE_DATE:
                    case FILE_MODIFY_DATE:
                    case FILE_ACCESS_DATE:      return(dbg_mqlapi_trace_func_FileGetInteger_datetime(file_handle, property_id));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, file_handle, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileGetInteger(file_handle, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_FileGetInteger_datetime(int file_handle, ENUM_FILE_PROPERTY_INTEGER property_id)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, file_handle, property_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (datetime)::FileGetInteger(file_handle, property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            long dbg_mqlapi_trace_func_FileGetInteger(const string file_name, ENUM_FILE_PROPERTY_INTEGER property_id, bool common_folder = false)
            {
                switch(property_id)
                {
                    case FILE_CREATE_DATE:
                    case FILE_MODIFY_DATE:
                    case FILE_ACCESS_DATE:      return(dbg_mqlapi_trace_func_FileGetInteger_datetime(file_name, property_id, common_folder));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_name, property_id, common_folder, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileGetInteger(file_name, property_id, common_folder);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_FileGetInteger_datetime(const string file_name, ENUM_FILE_PROPERTY_INTEGER property_id, bool common_folder = false)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_name, property_id, common_folder, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (datetime)::FileGetInteger(file_name, property_id, common_folder);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_FileIsEnding(int file_handle)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileIsEnding(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FileIsExist(const string file_name, int common_flag = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _FILE_COMMON         = ((common_flag & FILE_COMMON) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_name, common_flag, _FILE_COMMON, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileIsExist(file_name, common_flag);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FileIsLineEnding(int file_handle)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileIsLineEnding(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FileMove(const string src_file_name, int common_flag, const string dst_file_name, int mode_flags)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _FILE_COMMON         = ((common_flag & FILE_COMMON) != NULL);
                const bool _FILE_READ           = ((mode_flags & FILE_READ) != NULL);
                const bool _FILE_WRITE          = ((mode_flags & FILE_WRITE) != NULL);
                const bool _FILE_BIN            = ((mode_flags & FILE_BIN) != NULL);
                const bool _FILE_CSV            = ((mode_flags & FILE_CSV) != NULL);
                const bool _FILE_TXT            = ((mode_flags & FILE_TXT) != NULL);
                const bool _FILE_ANSI           = ((mode_flags & FILE_ANSI) != NULL);
                const bool _FILE_UNICODE        = ((mode_flags & FILE_UNICODE) != NULL);
                const bool _FILE_SHARE_READ     = ((mode_flags & FILE_SHARE_READ) != NULL);
                const bool _FILE_SHARE_WRITE    = ((mode_flags & FILE_SHARE_WRITE) != NULL);
                const bool _FILE_REWRITE        = ((mode_flags & FILE_REWRITE) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, _FILE_REWRITE, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, _FILE_BIN, _FILE_CSV, _FILE_TXT, _FILE_ANSI, _FILE_UNICODE, _FILE_SHARE_READ, _FILE_SHARE_WRITE);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, src_file_name, common_flag, dst_file_name, mode_flags, _FILE_COMMON, _FILE_READ, _FILE_WRITE);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileMove(src_file_name, common_flag, dst_file_name, mode_flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_FileOpen(string file_name, int open_flags, short delimiter = '\t', uint codepage = CP_ACP)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                string cp_name = NULL;
                switch(codepage)
                {
                    case CP_ACP:        cp_name = "CP_ACP";         break;
                    case CP_OEMCP:      cp_name = "CP_OEMCP";       break;
                    case CP_MACCP:      cp_name = "CP_MACCP";       break;
                    case CP_THREAD_ACP: cp_name = "CP_THREAD_ACP";  break;
                    case CP_SYMBOL:     cp_name = "CP_SYMBOL";      break;
                    case CP_UTF7:       cp_name = "CP_UTF7";        break;
                    case CP_UTF8:       cp_name = "CP_UTF8";        break;
                }
                const bool _FILE_COMMON         = ((open_flags & FILE_COMMON) != NULL);
                const bool _FILE_READ           = ((open_flags & FILE_READ) != NULL);
                const bool _FILE_WRITE          = ((open_flags & FILE_WRITE) != NULL);
                const bool _FILE_BIN            = ((open_flags & FILE_BIN) != NULL);
                const bool _FILE_CSV            = ((open_flags & FILE_CSV) != NULL);
                const bool _FILE_TXT            = ((open_flags & FILE_TXT) != NULL);
                const bool _FILE_ANSI           = ((open_flags & FILE_ANSI) != NULL);
                const bool _FILE_UNICODE        = ((open_flags & FILE_UNICODE) != NULL);
                const bool _FILE_SHARE_READ     = ((open_flags & FILE_SHARE_READ) != NULL);
                const bool _FILE_SHARE_WRITE    = ((open_flags & FILE_SHARE_WRITE) != NULL);
                const bool _FILE_REWRITE        = ((open_flags & FILE_REWRITE) != NULL);
                if(cp_name == NULL)
                {
                    DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, _FILE_REWRITE, 0, 0, 0, 0, 0, 0);
                    DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, _FILE_BIN, _FILE_CSV, _FILE_TXT, _FILE_ANSI, _FILE_UNICODE, _FILE_SHARE_READ, _FILE_SHARE_WRITE);
                    DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, file_name, open_flags, delimiter, codepage, _FILE_COMMON, _FILE_READ, _FILE_WRITE);
                }
                else
                {
                    DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, _FILE_SHARE_WRITE, _FILE_REWRITE, 0, 0, 0, 0, 0);
                    DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, _FILE_WRITE, _FILE_BIN, _FILE_CSV, _FILE_TXT, _FILE_ANSI, _FILE_UNICODE, _FILE_SHARE_READ);
                    DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, file_name, open_flags, delimiter, codepage, cp_name, _FILE_COMMON, _FILE_READ);
                }
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileOpen(file_name, open_flags, delimiter, codepage);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> uint dbg_mqlapi_trace_func_FileReadArray(int file_handle, T& array[], int start = 0, int count = WHOLE_ARRAY)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_handle, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadArray(file_handle, array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FileReadBool(int file_handle)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadBool(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_FileReadDatetime(int file_handle)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadDatetime(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_FileReadDouble(int file_handle)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadDouble(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            float dbg_mqlapi_trace_func_FileReadFloat(int file_handle)
            {
                float retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadFloat(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_FileReadInteger(int file_handle, int size = INT_VALUE)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, file_handle, size, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadInteger(file_handle, size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_FileReadLong(int file_handle)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadLong(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_FileReadNumber(int file_handle)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadNumber(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_FileReadString(int file_handle, int length = -1)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, file_handle, length, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadString(file_handle, length);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> uint dbg_mqlapi_trace_func_FileReadStruct(int file_handle, const T& struct_object, int size = -1)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_handle, struct_object, size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileReadStruct(file_handle, struct_object, size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FileSeek(int file_handle, long offset, ENUM_FILE_POSITION origin)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_handle, offset, origin, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileSeek(file_handle, offset, origin);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ulong dbg_mqlapi_trace_func_FileSize(int file_handle)
            {
                ulong retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileSize(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ulong dbg_mqlapi_trace_func_FileTell(int file_handle)
            {
                ulong retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileTell(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> uint dbg_mqlapi_trace_func_FileWriteArray(int file_handle, const T& array[], int start = 0, int count = WHOLE_ARRAY)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, file_handle, array, start, count, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileWriteArray(file_handle, array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_FileWriteDouble(int file_handle, double value)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, file_handle, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileWriteDouble(file_handle, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_FileWriteFloat(int file_handle, float value)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, file_handle, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileWriteFloat(file_handle, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_FileWriteInteger(int file_handle, int value, int size = INT_VALUE)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_handle, value, size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileWriteInteger(file_handle, value, size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_FileWriteLong(int file_handle, long value)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, file_handle, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileWriteLong(file_handle, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_FileWriteString(int file_handle, const string text_string, int length = -1)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_handle, text_string, length, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileWriteString(file_handle, text_string, length);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> uint dbg_mqlapi_trace_func_FileWriteStruct(int file_handle, const T& struct_object, int size = -1)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, file_handle, struct_object, size, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FileWriteStruct(file_handle, struct_object, size);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FolderClean(string folder_name, int common_flag = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _FILE_COMMON         = ((common_flag & FILE_COMMON) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, folder_name, common_flag, _FILE_COMMON, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FolderClean(folder_name, common_flag);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FolderCreate(string folder_name, int common_flag = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _FILE_COMMON         = ((common_flag & FILE_COMMON) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, folder_name, common_flag, _FILE_COMMON, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FolderCreate(folder_name, common_flag);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_FolderDelete(string folder_name, int common_flag = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _FILE_COMMON         = ((common_flag & FILE_COMMON) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, folder_name, common_flag, _FILE_COMMON, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::FolderDelete(folder_name, common_flag);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_GetLastError()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GetLastError();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ulong dbg_mqlapi_trace_func_GetMicrosecondCount()
            {
                ulong retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GetMicrosecondCount();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> T* dbg_mqlapi_trace_func_GetPointer(T& anyobject)
            {
                T* retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, anyobject, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GetPointer(anyobject);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename T> T* dbg_mqlapi_trace_func_GetPointer(T* anyobject)
            {
                T* retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, anyobject, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GetPointer(anyobject);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_GetTickCount()
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GetTickCount();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_GlobalVariableCheck(string name)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariableCheck(name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_GlobalVariableDel(string name)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariableDel(name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_GlobalVariableGet(string name)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariableGet(name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_GlobalVariableGet(string name, double& double_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariableGet(name, double_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, double_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_GlobalVariableName(int index)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariableName(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_GlobalVariablesDeleteAll(string prefix_name = NULL, datetime limit_data = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, prefix_name, limit_data, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariablesDeleteAll(prefix_name, limit_data);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_GlobalVariableSet(string name, double value)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariableSet(name, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_GlobalVariableSetOnCondition(string name, double value, double check_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, name, value, check_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariableSetOnCondition(name, value, check_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_GlobalVariablesTotal()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariablesTotal();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_GlobalVariableTemp(string name)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariableTemp(name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_GlobalVariableTime(string name)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::GlobalVariableTime(name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetDouble(ENUM_CUSTOMIND_PROPERTY_DOUBLE prop_id, double prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, prop_id, prop_value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetDouble(prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetDouble(ENUM_CUSTOMIND_PROPERTY_DOUBLE prop_id, int prop_modifier, double prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, prop_id, prop_modifier, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetDouble(prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetInteger(ENUM_CUSTOMIND_PROPERTY_INTEGER prop_id, int prop_value)
            {
                switch(prop_id)
                {
                    case INDICATOR_LEVELSTYLE:      return(dbg_mqlapi_trace_func_IndicatorSetInteger_ENUM_LINE_STYLE(prop_id, (ENUM_LINE_STYLE)prop_value));
                    case INDICATOR_LEVELCOLOR:      return(dbg_mqlapi_trace_func_IndicatorSetInteger_color(prop_id, (color)prop_value));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, prop_id, prop_value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetInteger(prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetInteger(ENUM_CUSTOMIND_PROPERTY_INTEGER prop_id, int prop_modifier, int prop_value)
            {
                switch(prop_id)
                {
                    case INDICATOR_LEVELSTYLE:      return(dbg_mqlapi_trace_func_IndicatorSetInteger_ENUM_LINE_STYLE(prop_id, prop_modifier, (ENUM_LINE_STYLE)prop_value));
                    case INDICATOR_LEVELCOLOR:      return(dbg_mqlapi_trace_func_IndicatorSetInteger_color(prop_id, prop_modifier, (color)prop_value));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, prop_id, prop_modifier, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetInteger(prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetInteger_ENUM_LINE_STYLE(ENUM_CUSTOMIND_PROPERTY_INTEGER prop_id, ENUM_LINE_STYLE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, prop_id, prop_value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetInteger(prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetInteger_ENUM_LINE_STYLE(ENUM_CUSTOMIND_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_LINE_STYLE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, prop_id, prop_modifier, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetInteger(prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetInteger_color(ENUM_CUSTOMIND_PROPERTY_INTEGER prop_id, color prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, prop_id, prop_value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetInteger(prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetInteger_color(ENUM_CUSTOMIND_PROPERTY_INTEGER prop_id, int prop_modifier, color prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, prop_id, prop_modifier, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetInteger(prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetString(ENUM_CUSTOMIND_PROPERTY_STRING prop_id, string prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, prop_id, prop_value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetString(prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IndicatorSetString(ENUM_CUSTOMIND_PROPERTY_STRING prop_id, int prop_modifier, string prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, prop_id, prop_modifier, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IndicatorSetString(prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_IntegerToString(long number, int str_len = 0, ushort fill_symbol = ' ')
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, number, str_len, fill_symbol, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IntegerToString(number, str_len, fill_symbol);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_IsStopped()
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::IsStopped();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_MathIsValidNumber(double number)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, number, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathIsValidNumber(number);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathAbs_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathAbs(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathArccos_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathArccos(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathArccosh_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathArccosh(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathArcsin_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathArcsin(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathArcsinh_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathArcsinh(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathArctan_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathArctan(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG1_TYPE, typename ARG2_TYPE> RET_TYPE MathArctan2_T(const ARG1_TYPE &value1, const ARG2_TYPE &value2)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, value1, value2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathArctan2(value1, value2);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathArctanh_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathArctanh(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathCeil_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathCeil(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathCos_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathCos(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathCosh_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathCosh(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathExp_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathExp(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathExpm1_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathExpm1(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathFloor_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathFloor(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathLog_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathLog(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathLog10_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathLog10(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathLog1p_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathLog1p(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }


            char  dbg_mqlapi_trace_func_MathMax(char value1, char value2)           { return(MathMax_T<char, char, char>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMax(char value1, short value2)         { return(MathMax_T<short, char, short>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMax(short value1, char value2)         { return(MathMax_T<short, short, char>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMax(short value1, short value2)        { return(MathMax_T<short, short, short>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMax(short value1, uchar value2)        { return(MathMax_T<short, short, uchar>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMax(uchar value1, short value2)        { return(MathMax_T<short, uchar, short>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMax(char value1, int value2)             { return(MathMax_T<int, char, int>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMax(int value1, char value2)             { return(MathMax_T<int, int, char>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMax(int value1, int value2)              { return(MathMax_T<int, int, int>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMax(int value1, short value2)            { return(MathMax_T<int, int, short>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMax(int value1, uchar value2)            { return(MathMax_T<int, int, uchar>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMax(int value1, ushort value2)           { return(MathMax_T<int, int, ushort>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMax(short value1, int value2)            { return(MathMax_T<int, short, int>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMax(uchar value1, int value2)            { return(MathMax_T<int, uchar, int>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMax(ushort value1, int value2)           { return(MathMax_T<int, ushort, int>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(char value1, long value2)           { return(MathMax_T<long, char, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(int value1, long value2)            { return(MathMax_T<long, int, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(long value1, char value2)           { return(MathMax_T<long, long, char>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(long value1, int value2)            { return(MathMax_T<long, long, int>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(long value1, long value2)           { return(MathMax_T<long, long, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(long value1, short value2)          { return(MathMax_T<long, long, short>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(long value1, uchar value2)          { return(MathMax_T<long, long, uchar>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(long value1, uint value2)           { return(MathMax_T<long, long, uint>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(long value1, ushort value2)         { return(MathMax_T<long, long, ushort>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(short value1, long value2)          { return(MathMax_T<long, short, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(uchar value1, long value2)          { return(MathMax_T<long, uchar, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(uint value1, long value2)           { return(MathMax_T<long, uint, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMax(ushort value1, long value2)         { return(MathMax_T<long, ushort, long>(value1, value2)); }
            uchar  dbg_mqlapi_trace_func_MathMax(char value1, uchar value2)         { return(MathMax_T<uchar, char, uchar>(value1, value2)); }
            uchar  dbg_mqlapi_trace_func_MathMax(uchar value1, char value2)         { return(MathMax_T<uchar, uchar, char>(value1, value2)); }
            uchar  dbg_mqlapi_trace_func_MathMax(uchar value1, uchar value2)        { return(MathMax_T<uchar, uchar, uchar>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMax(char value1, ushort value2)       { return(MathMax_T<ushort, char, ushort>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMax(short value1, ushort value2)      { return(MathMax_T<ushort, short, ushort>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMax(uchar value1, ushort value2)      { return(MathMax_T<ushort, uchar, ushort>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMax(ushort value1, char value2)       { return(MathMax_T<ushort, ushort, char>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMax(ushort value1, short value2)      { return(MathMax_T<ushort, ushort, short>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMax(ushort value1, uchar value2)      { return(MathMax_T<ushort, ushort, uchar>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMax(ushort value1, ushort value2)     { return(MathMax_T<ushort, ushort, ushort>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(char value1, uint value2)           { return(MathMax_T<uint, char, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(int value1, uint value2)            { return(MathMax_T<uint, int, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(short value1, uint value2)          { return(MathMax_T<uint, short, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(uchar value1, uint value2)          { return(MathMax_T<uint, uchar, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(uint value1, char value2)           { return(MathMax_T<uint, uint, char>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(uint value1, int value2)            { return(MathMax_T<uint, uint, int>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(uint value1, short value2)          { return(MathMax_T<uint, uint, short>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(uint value1, uchar value2)          { return(MathMax_T<uint, uint, uchar>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(uint value1, uint value2)           { return(MathMax_T<uint, uint, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(uint value1, ushort value2)         { return(MathMax_T<uint, uint, ushort>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMax(ushort value1, uint value2)         { return(MathMax_T<uint, ushort, uint>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(char value1, ulong value2)         { return(MathMax_T<ulong, char, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(int value1, ulong value2)          { return(MathMax_T<ulong, int, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(long value1, ulong value2)         { return(MathMax_T<ulong, long, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(short value1, ulong value2)        { return(MathMax_T<ulong, short, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(uchar value1, ulong value2)        { return(MathMax_T<ulong, uchar, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(uint value1, ulong value2)         { return(MathMax_T<ulong, uint, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(ulong value1, char value2)         { return(MathMax_T<ulong, ulong, char>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(ulong value1, int value2)          { return(MathMax_T<ulong, ulong, int>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(ulong value1, long value2)         { return(MathMax_T<ulong, ulong, long>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(ulong value1, short value2)        { return(MathMax_T<ulong, ulong, short>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(ulong value1, uchar value2)        { return(MathMax_T<ulong, ulong, uchar>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(ulong value1, uint value2)         { return(MathMax_T<ulong, ulong, uint>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(ulong value1, ulong value2)        { return(MathMax_T<ulong, ulong, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(ulong value1, ushort value2)       { return(MathMax_T<ulong, ulong, ushort>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMax(ushort value1, ulong value2)       { return(MathMax_T<ulong, ushort, ulong>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(char value1, float value2)         { return(MathMax_T<float, char, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(float value1, char value2)         { return(MathMax_T<float, float, char>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(float value1, float value2)        { return(MathMax_T<float, float, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(float value1, int value2)          { return(MathMax_T<float, float, int>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(float value1, long value2)         { return(MathMax_T<float, float, long>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(float value1, short value2)        { return(MathMax_T<float, float, short>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(float value1, uchar value2)        { return(MathMax_T<float, float, uchar>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(float value1, uint value2)         { return(MathMax_T<float, float, uint>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(float value1, ulong value2)        { return(MathMax_T<float, float, ulong>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(float value1, ushort value2)       { return(MathMax_T<float, float, ushort>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(int value1, float value2)          { return(MathMax_T<float, int, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(long value1, float value2)         { return(MathMax_T<float, long, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(short value1, float value2)        { return(MathMax_T<float, short, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(uchar value1, float value2)        { return(MathMax_T<float, uchar, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(uint value1, float value2)         { return(MathMax_T<float, uint, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(ulong value1, float value2)        { return(MathMax_T<float, ulong, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMax(ushort value1, float value2)       { return(MathMax_T<float, ushort, float>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(char value1, double value2)       { return(MathMax_T<double, char, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, char value2)       { return(MathMax_T<double, double, char>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, double value2)     { return(MathMax_T<double, double, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, float value2)      { return(MathMax_T<double, double, float>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, int value2)        { return(MathMax_T<double, double, int>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, long value2)       { return(MathMax_T<double, double, long>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, short value2)      { return(MathMax_T<double, double, short>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, uchar value2)      { return(MathMax_T<double, double, uchar>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, uint value2)       { return(MathMax_T<double, double, uint>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, ulong value2)      { return(MathMax_T<double, double, ulong>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(double value1, ushort value2)     { return(MathMax_T<double, double, ushort>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(float value1, double value2)      { return(MathMax_T<double, float, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(int value1, double value2)        { return(MathMax_T<double, int, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(long value1, double value2)       { return(MathMax_T<double, long, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(short value1, double value2)      { return(MathMax_T<double, short, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(uchar value1, double value2)      { return(MathMax_T<double, uchar, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(uint value1, double value2)       { return(MathMax_T<double, uint, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(ulong value1, double value2)      { return(MathMax_T<double, ulong, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMax(ushort value1, double value2)     { return(MathMax_T<double, ushort, double>(value1, value2)); }
            string  dbg_mqlapi_trace_func_MathMax(string value1, string value2)     { return(MathMax_T<string, string, string>(value1, value2)); }
            template <typename RET_TYPE, typename ARG1_TYPE, typename ARG2_TYPE> RET_TYPE  MathMax_T(const ARG1_TYPE &value1, const ARG2_TYPE &value2)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, value1, value2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathMax(value1, value2);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            char  dbg_mqlapi_trace_func_MathMin(char value1, char value2)           { return(MathMin_T<char, char, char>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMin(char value1, short value2)         { return(MathMin_T<short, char, short>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMin(short value1, char value2)         { return(MathMin_T<short, short, char>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMin(short value1, short value2)        { return(MathMin_T<short, short, short>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMin(short value1, uchar value2)        { return(MathMin_T<short, short, uchar>(value1, value2)); }
            short  dbg_mqlapi_trace_func_MathMin(uchar value1, short value2)        { return(MathMin_T<short, uchar, short>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMin(char value1, int value2)             { return(MathMin_T<int, char, int>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMin(int value1, char value2)             { return(MathMin_T<int, int, char>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMin(int value1, int value2)              { return(MathMin_T<int, int, int>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMin(int value1, short value2)            { return(MathMin_T<int, int, short>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMin(int value1, uchar value2)            { return(MathMin_T<int, int, uchar>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMin(int value1, ushort value2)           { return(MathMin_T<int, int, ushort>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMin(short value1, int value2)            { return(MathMin_T<int, short, int>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMin(uchar value1, int value2)            { return(MathMin_T<int, uchar, int>(value1, value2)); }
            int  dbg_mqlapi_trace_func_MathMin(ushort value1, int value2)           { return(MathMin_T<int, ushort, int>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(char value1, long value2)           { return(MathMin_T<long, char, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(int value1, long value2)            { return(MathMin_T<long, int, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(long value1, char value2)           { return(MathMin_T<long, long, char>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(long value1, int value2)            { return(MathMin_T<long, long, int>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(long value1, long value2)           { return(MathMin_T<long, long, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(long value1, short value2)          { return(MathMin_T<long, long, short>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(long value1, uchar value2)          { return(MathMin_T<long, long, uchar>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(long value1, uint value2)           { return(MathMin_T<long, long, uint>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(long value1, ushort value2)         { return(MathMin_T<long, long, ushort>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(short value1, long value2)          { return(MathMin_T<long, short, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(uchar value1, long value2)          { return(MathMin_T<long, uchar, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(uint value1, long value2)           { return(MathMin_T<long, uint, long>(value1, value2)); }
            long  dbg_mqlapi_trace_func_MathMin(ushort value1, long value2)         { return(MathMin_T<long, ushort, long>(value1, value2)); }
            uchar  dbg_mqlapi_trace_func_MathMin(char value1, uchar value2)         { return(MathMin_T<uchar, char, uchar>(value1, value2)); }
            uchar  dbg_mqlapi_trace_func_MathMin(uchar value1, char value2)         { return(MathMin_T<uchar, uchar, char>(value1, value2)); }
            uchar  dbg_mqlapi_trace_func_MathMin(uchar value1, uchar value2)        { return(MathMin_T<uchar, uchar, uchar>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMin(char value1, ushort value2)       { return(MathMin_T<ushort, char, ushort>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMin(short value1, ushort value2)      { return(MathMin_T<ushort, short, ushort>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMin(uchar value1, ushort value2)      { return(MathMin_T<ushort, uchar, ushort>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMin(ushort value1, char value2)       { return(MathMin_T<ushort, ushort, char>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMin(ushort value1, short value2)      { return(MathMin_T<ushort, ushort, short>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMin(ushort value1, uchar value2)      { return(MathMin_T<ushort, ushort, uchar>(value1, value2)); }
            ushort  dbg_mqlapi_trace_func_MathMin(ushort value1, ushort value2)     { return(MathMin_T<ushort, ushort, ushort>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(char value1, uint value2)           { return(MathMin_T<uint, char, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(int value1, uint value2)            { return(MathMin_T<uint, int, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(short value1, uint value2)          { return(MathMin_T<uint, short, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(uchar value1, uint value2)          { return(MathMin_T<uint, uchar, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(uint value1, char value2)           { return(MathMin_T<uint, uint, char>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(uint value1, int value2)            { return(MathMin_T<uint, uint, int>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(uint value1, short value2)          { return(MathMin_T<uint, uint, short>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(uint value1, uchar value2)          { return(MathMin_T<uint, uint, uchar>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(uint value1, uint value2)           { return(MathMin_T<uint, uint, uint>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(uint value1, ushort value2)         { return(MathMin_T<uint, uint, ushort>(value1, value2)); }
            uint  dbg_mqlapi_trace_func_MathMin(ushort value1, uint value2)         { return(MathMin_T<uint, ushort, uint>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(char value1, ulong value2)         { return(MathMin_T<ulong, char, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(int value1, ulong value2)          { return(MathMin_T<ulong, int, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(long value1, ulong value2)         { return(MathMin_T<ulong, long, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(short value1, ulong value2)        { return(MathMin_T<ulong, short, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(uchar value1, ulong value2)        { return(MathMin_T<ulong, uchar, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(uint value1, ulong value2)         { return(MathMin_T<ulong, uint, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(ulong value1, char value2)         { return(MathMin_T<ulong, ulong, char>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(ulong value1, int value2)          { return(MathMin_T<ulong, ulong, int>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(ulong value1, long value2)         { return(MathMin_T<ulong, ulong, long>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(ulong value1, short value2)        { return(MathMin_T<ulong, ulong, short>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(ulong value1, uchar value2)        { return(MathMin_T<ulong, ulong, uchar>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(ulong value1, uint value2)         { return(MathMin_T<ulong, ulong, uint>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(ulong value1, ulong value2)        { return(MathMin_T<ulong, ulong, ulong>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(ulong value1, ushort value2)       { return(MathMin_T<ulong, ulong, ushort>(value1, value2)); }
            ulong  dbg_mqlapi_trace_func_MathMin(ushort value1, ulong value2)       { return(MathMin_T<ulong, ushort, ulong>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(char value1, float value2)         { return(MathMin_T<float, char, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(float value1, char value2)         { return(MathMin_T<float, float, char>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(float value1, float value2)        { return(MathMin_T<float, float, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(float value1, int value2)          { return(MathMin_T<float, float, int>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(float value1, long value2)         { return(MathMin_T<float, float, long>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(float value1, short value2)        { return(MathMin_T<float, float, short>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(float value1, uchar value2)        { return(MathMin_T<float, float, uchar>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(float value1, uint value2)         { return(MathMin_T<float, float, uint>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(float value1, ulong value2)        { return(MathMin_T<float, float, ulong>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(float value1, ushort value2)       { return(MathMin_T<float, float, ushort>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(int value1, float value2)          { return(MathMin_T<float, int, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(long value1, float value2)         { return(MathMin_T<float, long, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(short value1, float value2)        { return(MathMin_T<float, short, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(uchar value1, float value2)        { return(MathMin_T<float, uchar, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(uint value1, float value2)         { return(MathMin_T<float, uint, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(ulong value1, float value2)        { return(MathMin_T<float, ulong, float>(value1, value2)); }
            float  dbg_mqlapi_trace_func_MathMin(ushort value1, float value2)       { return(MathMin_T<float, ushort, float>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(char value1, double value2)       { return(MathMin_T<double, char, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, char value2)       { return(MathMin_T<double, double, char>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, double value2)     { return(MathMin_T<double, double, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, float value2)      { return(MathMin_T<double, double, float>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, int value2)        { return(MathMin_T<double, double, int>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, long value2)       { return(MathMin_T<double, double, long>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, short value2)      { return(MathMin_T<double, double, short>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, uchar value2)      { return(MathMin_T<double, double, uchar>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, uint value2)       { return(MathMin_T<double, double, uint>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, ulong value2)      { return(MathMin_T<double, double, ulong>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(double value1, ushort value2)     { return(MathMin_T<double, double, ushort>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(float value1, double value2)      { return(MathMin_T<double, float, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(int value1, double value2)        { return(MathMin_T<double, int, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(long value1, double value2)       { return(MathMin_T<double, long, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(short value1, double value2)      { return(MathMin_T<double, short, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(uchar value1, double value2)      { return(MathMin_T<double, uchar, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(uint value1, double value2)       { return(MathMin_T<double, uint, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(ulong value1, double value2)      { return(MathMin_T<double, ulong, double>(value1, value2)); }
            double  dbg_mqlapi_trace_func_MathMin(ushort value1, double value2)     { return(MathMin_T<double, ushort, double>(value1, value2)); }
            string  dbg_mqlapi_trace_func_MathMin(string value1, string value2)     { return(MathMin_T<string, string, string>(value1, value2)); }
            template <typename RET_TYPE, typename ARG1_TYPE, typename ARG2_TYPE> RET_TYPE MathMin_T(const ARG1_TYPE &value1, const ARG2_TYPE &value2)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, value1, value2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathMin(value1, value2);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG1_TYPE, typename ARG2_TYPE> RET_TYPE MathMod_T(const ARG1_TYPE &value, const ARG2_TYPE &value2)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, value, value2, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathMod(value, value2);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG1_TYPE, typename ARG2_TYPE> RET_TYPE MathPow_T(const ARG1_TYPE &base, const ARG2_TYPE &exponent)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, base, exponent, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathPow(base, exponent);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathRound_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathRound(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathSin_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathSin(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathSinh_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathSinh(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathSqrt_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathSqrt(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathTan_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathTan(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            template <typename RET_TYPE, typename ARG_TYPE> RET_TYPE MathTanh_T(const ARG_TYPE &value)
            {
                RET_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathTanh(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            }
            int dbg_mqlapi_trace_func_MathRand()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MathRand();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_MessageBox(string text, string caption = NULL, int flags = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _MB_OK                           = ((flags & MB_OK) != NULL);
                const bool _MB_OKCANCEL                     = ((flags & MB_OKCANCEL) != NULL);
                const bool _MB_ABORTRETRYIGNORE             = ((flags & MB_ABORTRETRYIGNORE) != NULL);
                const bool _MB_YESNOCANCEL                  = ((flags & MB_YESNOCANCEL) != NULL);
                const bool _MB_YESNO                        = ((flags & MB_YESNO) != NULL);
                const bool _MB_RETRYCANCEL                  = ((flags & MB_RETRYCANCEL) != NULL);
                const bool _MB_CANCELTRYCONTINUE            = ((flags & MB_CANCELTRYCONTINUE) != NULL);
                const bool _MB_ICONSTOP_ERR_HAND            = ((flags & MB_ICONSTOP) != NULL);
                const bool _MB_ICONQUESTION                 = ((flags & MB_ICONQUESTION) != NULL);
                const bool _MB_ICON_WARNING_EXCLAMATION     = ((flags & MB_ICONEXCLAMATION) != NULL);
                const bool _MB_ICON_ASTERISK_INFORMATION    = ((flags & MB_ICONINFORMATION) != NULL);
                const bool _MB_DEFBUTTON1                   = ((flags & MB_DEFBUTTON1) != NULL);
                const bool _MB_DEFBUTTON2                   = ((flags & MB_DEFBUTTON2) != NULL);
                const bool _MB_DEFBUTTON3                   = ((flags & MB_DEFBUTTON3) != NULL);
                const bool _MB_DEFBUTTON4                   = ((flags & MB_DEFBUTTON4) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, _MB_DEFBUTTON1, _MB_DEFBUTTON2, _MB_DEFBUTTON3, _MB_DEFBUTTON4, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, _MB_YESNO, _MB_RETRYCANCEL, _MB_CANCELTRYCONTINUE, _MB_ICONSTOP_ERR_HAND, _MB_ICONQUESTION, _MB_ICON_WARNING_EXCLAMATION, _MB_ICON_ASTERISK_INFORMATION);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, text, caption, flags, _MB_OK, _MB_OKCANCEL, _MB_ABORTRETRYIGNORE, _MB_YESNOCANCEL);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MessageBox(text, caption, flags);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const bool _IDOK                            = ((retval & IDOK) != NULL);
                const bool _IDCANCEL                        = ((retval & IDCANCEL) != NULL);
                const bool _IDABORT                         = ((retval & IDABORT) != NULL);
                const bool _IDRETRY                         = ((retval & IDRETRY) != NULL);
                const bool _IDIGNORE                        = ((retval & IDIGNORE) != NULL);
                const bool _IDYES                           = ((retval & IDYES) != NULL);
                const bool _IDNO                            = ((retval & IDNO) != NULL);
                const bool _IDTRYAGAIN                      = ((retval & IDTRYAGAIN) != NULL);
                const bool _IDCONTINUE                      = ((retval & IDCONTINUE) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, _IDTRYAGAIN, _IDCONTINUE, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(7, _IDOK, _IDCANCEL, _IDABORT, _IDRETRY, _IDIGNORE, _IDYES, _IDNO);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_MQLInfoInteger(ENUM_MQL_INFO_INTEGER property_id)
            {
                switch(property_id)
                {
                    case MQL_PROGRAM_TYPE:      return(dbg_mqlapi_trace_func_MQLInfoInteger_ENUM_PROGRAM_TYPE(property_id));
                    case MQL_LICENSE_TYPE:      return(dbg_mqlapi_trace_func_MQLInfoInteger_ENUM_LICENSE_TYPE(property_id));
                }
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MQLInfoInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_MQLInfoInteger_ENUM_PROGRAM_TYPE(ENUM_MQL_INFO_INTEGER property_id)
            {
                ENUM_PROGRAM_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_PROGRAM_TYPE)::MQLInfoInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((int)retval);
            };
            int dbg_mqlapi_trace_func_MQLInfoInteger_ENUM_LICENSE_TYPE(ENUM_MQL_INFO_INTEGER property_id)
            {
                ENUM_LICENSE_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_LICENSE_TYPE)::MQLInfoInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((int)retval);
            };
            string dbg_mqlapi_trace_func_MQLInfoString(ENUM_MQL_INFO_STRING property_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::MQLInfoString(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_NormalizeDouble(double value, int digits)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, value, digits, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::NormalizeDouble(value, digits);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectDelete(long chart_id, string name)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, chart_id, name, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectDelete(chart_id, name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectFind(long chart_id, string name)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, chart_id, name, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectFind(chart_id, name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_ObjectGetDouble(long chart_id, string name, ENUM_OBJECT_PROPERTY_DOUBLE prop_id, int prop_modifier = 0)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetDouble(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetDouble(long chart_id, string name, ENUM_OBJECT_PROPERTY_DOUBLE prop_id, int prop_modifier, double& double_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetDouble(chart_id, name, prop_id, prop_modifier, double_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, double_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                switch(prop_id)
                {
                    case OBJPROP_TYPE:          return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_OBJECT(chart_id, name, prop_id, prop_modifier));
                    case OBJPROP_STYLE:
                    case OBJPROP_LEVELSTYLE:    return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_LINE_STYLE(chart_id, name, prop_id, prop_modifier));
                    case OBJPROP_ALIGN:         return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ALIGN_MODE(chart_id, name, prop_id, prop_modifier));
                    case OBJPROP_ANCHOR:        
                        if(((ENUM_OBJECT)::ObjectGetInteger(chart_id, name, OBJPROP_TYPE, prop_modifier)) == OBJ_ARROW)
                        {                       return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ARROW_ANCHOR(chart_id, name, prop_id, prop_modifier)); }
                                                return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ANCHOR_POINT(chart_id, name, prop_id, prop_modifier));
                    case OBJPROP_DIRECTION:     return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_GANN_DIRECTION(chart_id, name, prop_id, prop_modifier));
                #ifndef __MQL4__
                    case OBJPROP_DEGREE:        return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ELLIOT_WAVE_DEGREE(chart_id, name, prop_id, prop_modifier));

                #endif
                    case OBJPROP_PERIOD:        return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_TIMEFRAMES(chart_id, name, prop_id, prop_modifier));
                    case OBJPROP_CORNER:        return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_BASE_CORNER(chart_id, name, prop_id, prop_modifier));
                    case OBJPROP_BORDER_TYPE:   return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_BORDER_TYPE(chart_id, name, prop_id, prop_modifier));

                    case OBJPROP_TIME:          
                    case OBJPROP_CREATETIME:    return(dbg_mqlapi_trace_func_ObjectGetInteger_datetime(chart_id, name, prop_id, prop_modifier));
                    case OBJPROP_COLOR:
                    case OBJPROP_LEVELCOLOR:    
                    case OBJPROP_BGCOLOR:       
                    case OBJPROP_BORDER_COLOR:  return(dbg_mqlapi_trace_func_ObjectGetInteger_color(chart_id, name, prop_id, prop_modifier));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& long_var)
            {
                switch(prop_id)
                {
                    case OBJPROP_TYPE:          return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_OBJECT(chart_id, name, prop_id, prop_modifier, long_var));
                    case OBJPROP_STYLE:
                    case OBJPROP_LEVELSTYLE:    return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_LINE_STYLE(chart_id, name, prop_id, prop_modifier, long_var));
                    case OBJPROP_ALIGN:         return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ALIGN_MODE(chart_id, name, prop_id, prop_modifier, long_var));
                    case OBJPROP_ANCHOR:        
                        if(((ENUM_OBJECT)::ObjectGetInteger(chart_id, name, OBJPROP_TYPE, prop_modifier)) == OBJ_ARROW)
                        {                       return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ARROW_ANCHOR(chart_id, name, prop_id, prop_modifier, long_var)); }
                                                return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ANCHOR_POINT(chart_id, name, prop_id, prop_modifier, long_var));
                    case OBJPROP_DIRECTION:     return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_GANN_DIRECTION(chart_id, name, prop_id, prop_modifier, long_var));
                #ifndef __MQL4__
                    case OBJPROP_DEGREE:        return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ELLIOT_WAVE_DEGREE(chart_id, name, prop_id, prop_modifier, long_var));

                #endif
                    case OBJPROP_PERIOD:        return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_TIMEFRAMES(chart_id, name, prop_id, prop_modifier, long_var));
                    case OBJPROP_CORNER:        return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_BASE_CORNER(chart_id, name, prop_id, prop_modifier, long_var));
                    case OBJPROP_BORDER_TYPE:   return(dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_BORDER_TYPE(chart_id, name, prop_id, prop_modifier, long_var));

                    case OBJPROP_TIME:          
                    case OBJPROP_CREATETIME:    return(dbg_mqlapi_trace_func_ObjectGetInteger_datetime(chart_id, name, prop_id, prop_modifier, long_var));
                    case OBJPROP_COLOR:
                    case OBJPROP_LEVELCOLOR:    
                    case OBJPROP_BGCOLOR:       
                    case OBJPROP_BORDER_COLOR:  return(dbg_mqlapi_trace_func_ObjectGetInteger_color(chart_id, name, prop_id, prop_modifier, long_var));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_OBJECT(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_OBJECT retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_OBJECT)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_OBJECT(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_OBJECT long_var = (ENUM_OBJECT)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_LINE_STYLE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_LINE_STYLE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_LINE_STYLE)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_LINE_STYLE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_LINE_STYLE long_var = (ENUM_LINE_STYLE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ALIGN_MODE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_ALIGN_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ALIGN_MODE)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ALIGN_MODE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_ALIGN_MODE long_var = (ENUM_ALIGN_MODE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ARROW_ANCHOR(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_ARROW_ANCHOR retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ARROW_ANCHOR)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ARROW_ANCHOR(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_ARROW_ANCHOR long_var = (ENUM_ARROW_ANCHOR)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ANCHOR_POINT(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_ANCHOR_POINT retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ANCHOR_POINT)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ANCHOR_POINT(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_ANCHOR_POINT long_var = (ENUM_ANCHOR_POINT)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_GANN_DIRECTION(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_GANN_DIRECTION retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_GANN_DIRECTION)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_GANN_DIRECTION(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_GANN_DIRECTION long_var = (ENUM_GANN_DIRECTION)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
        #ifndef __MQL4__
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ELLIOT_WAVE_DEGREE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_ELLIOT_WAVE_DEGREE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ELLIOT_WAVE_DEGREE)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_ELLIOT_WAVE_DEGREE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_ELLIOT_WAVE_DEGREE long_var = (ENUM_ELLIOT_WAVE_DEGREE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

        #endif
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_TIMEFRAMES(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_TIMEFRAMES retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_TIMEFRAMES)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_TIMEFRAMES(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_TIMEFRAMES long_var = (ENUM_TIMEFRAMES)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_BASE_CORNER(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_BASE_CORNER retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_BASE_CORNER)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_BASE_CORNER(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_BASE_CORNER long_var = (ENUM_BASE_CORNER)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_BORDER_TYPE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                ENUM_BORDER_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_BORDER_TYPE)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_ENUM_BORDER_TYPE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_BORDER_TYPE long_var = (ENUM_BORDER_TYPE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_datetime(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (datetime)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_datetime(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const datetime long_var = (datetime)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_ObjectGetInteger_color(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier = 0)
            {
                color retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (color)::ObjectGetInteger(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetInteger_color(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetInteger(chart_id, name, prop_id, prop_modifier, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const color long_var = (color)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ObjectGetString(long chart_id, string name, ENUM_OBJECT_PROPERTY_STRING prop_id, int prop_modifier = 0)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetString(chart_id, name, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectGetString(long chart_id, string name, ENUM_OBJECT_PROPERTY_STRING prop_id, int prop_modifier, string& string_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_modifier, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetString(chart_id, name, prop_id, prop_modifier, string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_ObjectGetTimeByValue(long chart_id, string name, double value, int line_id)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, value, line_id, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetTimeByValue(chart_id, name, value, line_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_ObjectGetValueByTime(long chart_id, string name, datetime time, int line_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, time, line_id, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectGetValueByTime(chart_id, name, time, line_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectMove(long chart_id, string name, int point_index, datetime time, double price)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, point_index, time, price, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectMove(chart_id, name, point_index, time, price);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ObjectName(long chart_id, int pos, int sub_window = -1, int type = -1)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, pos, sub_window, type, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectName(chart_id, pos, sub_window, type);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectsDeleteAll(long chart_id, int sub_window = -1, int type = -1)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, sub_window, type, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectsDeleteAll(chart_id, sub_window, type);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectsDeleteAll(long chart_id, const string prefix, int sub_window = -1, int object_type = -1)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, prefix, sub_window, object_type, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectsDeleteAll(chart_id, prefix, sub_window, object_type);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetDouble(long chart_id, string name, ENUM_OBJECT_PROPERTY_DOUBLE prop_id, double prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetDouble(chart_id, name, prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetDouble(long chart_id, string name, ENUM_OBJECT_PROPERTY_DOUBLE prop_id, int prop_modifier, double prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetDouble(chart_id, name, prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, long prop_value)
            {
                switch(prop_id)
                {
                    case OBJPROP_TYPE:          return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_OBJECT(chart_id, name, prop_id, (ENUM_OBJECT)prop_value));
                    case OBJPROP_STYLE:
                    case OBJPROP_LEVELSTYLE:    return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_LINE_STYLE(chart_id, name, prop_id, (ENUM_LINE_STYLE)prop_value));
                    case OBJPROP_ALIGN:         return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ALIGN_MODE(chart_id, name, prop_id, (ENUM_ALIGN_MODE)prop_value));
                    case OBJPROP_ANCHOR:      
                        if(((ENUM_OBJECT)::ObjectGetInteger(chart_id, name, OBJPROP_TYPE)) == OBJ_ARROW)
                        {                       return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ARROW_ANCHOR(chart_id, name, prop_id, (ENUM_ARROW_ANCHOR)prop_value)); }
                                                return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ANCHOR_POINT(chart_id, name, prop_id, (ENUM_ANCHOR_POINT)prop_value));
                    case OBJPROP_DIRECTION:     return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_GANN_DIRECTION(chart_id, name, prop_id, (ENUM_GANN_DIRECTION)prop_value));
                #ifndef __MQL4__
                    case OBJPROP_DEGREE:        return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ELLIOT_WAVE_DEGREE(chart_id, name, prop_id, (ENUM_ELLIOT_WAVE_DEGREE)prop_value));

                #endif
                    case OBJPROP_PERIOD:        return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_TIMEFRAMES(chart_id, name, prop_id, (ENUM_TIMEFRAMES)prop_value));
                    case OBJPROP_CORNER:        return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_BASE_CORNER(chart_id, name, prop_id, (ENUM_BASE_CORNER)prop_value));
                    case OBJPROP_BORDER_TYPE:   return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_BORDER_TYPE(chart_id, name, prop_id, (ENUM_BORDER_TYPE)prop_value));

                    case OBJPROP_TIME:          
                    case OBJPROP_CREATETIME:    return(dbg_mqlapi_trace_func_ObjectSetInteger_datetime(chart_id, name, prop_id, (datetime)prop_value));
                    case OBJPROP_COLOR:
                    case OBJPROP_LEVELCOLOR:    
                    case OBJPROP_BGCOLOR:       
                    case OBJPROP_BORDER_COLOR:  return(dbg_mqlapi_trace_func_ObjectSetInteger_color(chart_id, name, prop_id, (color)prop_value));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, long prop_value)
            {
                switch(prop_id)
                {
                    case OBJPROP_TYPE:          return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_OBJECT(chart_id, name, prop_id, prop_modifier, (ENUM_OBJECT)prop_value));
                    case OBJPROP_STYLE:
                    case OBJPROP_LEVELSTYLE:    return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_LINE_STYLE(chart_id, name, prop_id, prop_modifier, (ENUM_LINE_STYLE)prop_value));
                    case OBJPROP_ALIGN:         return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ALIGN_MODE(chart_id, name, prop_id, prop_modifier, (ENUM_ALIGN_MODE)prop_value));
                    case OBJPROP_ANCHOR:      
                        if(((ENUM_OBJECT)::ObjectGetInteger(chart_id, name, OBJPROP_TYPE, prop_modifier)) == OBJ_ARROW)
                        {                       return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ARROW_ANCHOR(chart_id, name, prop_id, prop_modifier, (ENUM_ARROW_ANCHOR)prop_value)); }
                                                return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ANCHOR_POINT(chart_id, name, prop_id, prop_modifier, (ENUM_ANCHOR_POINT)prop_value));
                    case OBJPROP_DIRECTION:     return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_GANN_DIRECTION(chart_id, name, prop_id, prop_modifier, (ENUM_GANN_DIRECTION)prop_value));
                #ifndef __MQL4__
                    case OBJPROP_DEGREE:        return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ELLIOT_WAVE_DEGREE(chart_id, name, prop_id, prop_modifier, (ENUM_ELLIOT_WAVE_DEGREE)prop_value));

                #endif
                    case OBJPROP_PERIOD:        return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_TIMEFRAMES(chart_id, name, prop_id, prop_modifier, (ENUM_TIMEFRAMES)prop_value));
                    case OBJPROP_CORNER:        return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_BASE_CORNER(chart_id, name, prop_id, prop_modifier, (ENUM_BASE_CORNER)prop_value));
                    case OBJPROP_BORDER_TYPE:   return(dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_BORDER_TYPE(chart_id, name, prop_id, prop_modifier, (ENUM_BORDER_TYPE)prop_value));

                    case OBJPROP_TIME:          
                    case OBJPROP_CREATETIME:    return(dbg_mqlapi_trace_func_ObjectSetInteger_datetime(chart_id, name, prop_id, prop_modifier, (datetime)prop_value));
                    case OBJPROP_COLOR:
                    case OBJPROP_LEVELCOLOR:    
                    case OBJPROP_BGCOLOR:       
                    case OBJPROP_BORDER_COLOR:  return(dbg_mqlapi_trace_func_ObjectSetInteger_color(chart_id, name, prop_id, prop_modifier, (color)prop_value));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_OBJECT(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_OBJECT prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_OBJECT(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_OBJECT prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_LINE_STYLE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_LINE_STYLE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_LINE_STYLE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_LINE_STYLE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ALIGN_MODE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_ALIGN_MODE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ALIGN_MODE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_ALIGN_MODE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ARROW_ANCHOR(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_ARROW_ANCHOR prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ARROW_ANCHOR(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_ARROW_ANCHOR prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ANCHOR_POINT(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_ANCHOR_POINT prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ANCHOR_POINT(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_ANCHOR_POINT prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_GANN_DIRECTION(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_GANN_DIRECTION prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_GANN_DIRECTION(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_GANN_DIRECTION prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
        #ifndef __MQL4__
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ELLIOT_WAVE_DEGREE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_ELLIOT_WAVE_DEGREE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_ELLIOT_WAVE_DEGREE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_ELLIOT_WAVE_DEGREE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

        #endif
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_TIMEFRAMES(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_TIMEFRAMES prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_TIMEFRAMES(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_TIMEFRAMES prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_BASE_CORNER(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_BASE_CORNER prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_BASE_CORNER(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_BASE_CORNER prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_BORDER_TYPE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, ENUM_BORDER_TYPE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_ENUM_BORDER_TYPE(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_BORDER_TYPE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_datetime(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, datetime prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_datetime(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, datetime prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_color(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, color prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetInteger_color(long chart_id, string name, ENUM_OBJECT_PROPERTY_INTEGER prop_id, int prop_modifier, color prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetInteger(chart_id, name, prop_id, prop_modifier, (long)prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetString(long chart_id, string name, ENUM_OBJECT_PROPERTY_STRING prop_id, string prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, chart_id, name, prop_id, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetString(chart_id, name, prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ObjectSetString(long chart_id, string name, ENUM_OBJECT_PROPERTY_STRING prop_id, int prop_modifier, string prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, chart_id, name, prop_id, prop_modifier, prop_value, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectSetString(chart_id, name, prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectsTotal(long chart_id, int sub_window = -1, int type = -1)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, chart_id, sub_window, type, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectsTotal(chart_id, sub_window, type);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_OrderGetDouble(ENUM_ORDER_PROPERTY_DOUBLE property_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetDouble(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderGetDouble(ENUM_ORDER_PROPERTY_DOUBLE property_id, double& double_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetDouble(property_id, double_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, double_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_OrderGetInteger(ENUM_ORDER_PROPERTY_INTEGER property_id)
            {
                switch(property_id)
                {
                    case ORDER_TYPE:                return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE(property_id));
                #ifndef __MQL4__
                    case ORDER_TYPE_TIME:           return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE_TIME(property_id));
                    case ORDER_STATE:               return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_STATE(property_id));
                    case ORDER_TYPE_FILLING:        return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE_FILLING(property_id));
                    case ORDER_REASON:              return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_REASON(property_id));

                #endif
                    case ORDER_TIME_SETUP:
                    case ORDER_TIME_EXPIRATION:
                    case ORDER_TIME_DONE:           return(dbg_mqlapi_trace_func_OrderGetInteger_datetime(property_id));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderGetInteger(ENUM_ORDER_PROPERTY_INTEGER property_id, long& long_var)
            {
                switch(property_id)
                {
                    case ORDER_TYPE:                return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE(property_id, long_var));
                #ifndef __MQL4__
                    case ORDER_TYPE_TIME:           return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE_TIME(property_id, long_var));
                    case ORDER_STATE:               return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_STATE(property_id, long_var));
                    case ORDER_TYPE_FILLING:        return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE_FILLING(property_id, long_var));
                    case ORDER_REASON:              return(dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_REASON(property_id, long_var));

                #endif
                    case ORDER_TIME_SETUP:
                    case ORDER_TIME_EXPIRATION:
                    case ORDER_TIME_DONE:           return(dbg_mqlapi_trace_func_OrderGetInteger_datetime(property_id, long_var));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetInteger(property_id, long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE(ENUM_ORDER_PROPERTY_INTEGER property_id)
            {
                ENUM_ORDER_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ORDER_TYPE)::OrderGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE(ENUM_ORDER_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetInteger(property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_ORDER_TYPE long_var = (ENUM_ORDER_TYPE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
        #ifndef __MQL4__
            long dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_STATE(ENUM_ORDER_PROPERTY_INTEGER property_id)
            {
                ENUM_ORDER_STATE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ORDER_STATE)::OrderGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_STATE(ENUM_ORDER_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetInteger(property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_ORDER_STATE long_var = (ENUM_ORDER_STATE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE_FILLING(ENUM_ORDER_PROPERTY_INTEGER property_id)
            {
                ENUM_ORDER_TYPE_FILLING retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ORDER_TYPE_FILLING)::OrderGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE_FILLING(ENUM_ORDER_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetInteger(property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_ORDER_TYPE_FILLING long_var = (ENUM_ORDER_TYPE_FILLING)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE_TIME(ENUM_ORDER_PROPERTY_INTEGER property_id)
            {
                ENUM_ORDER_TYPE_TIME retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ORDER_TYPE_TIME)::OrderGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_TYPE_TIME(ENUM_ORDER_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetInteger(property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_ORDER_TYPE_TIME long_var = (ENUM_ORDER_TYPE_TIME)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_REASON(ENUM_ORDER_PROPERTY_INTEGER property_id)
            {
                ENUM_ORDER_REASON retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_ORDER_REASON)::OrderGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_OrderGetInteger_ENUM_ORDER_REASON(ENUM_ORDER_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetInteger(property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_ORDER_REASON long_var = (ENUM_ORDER_REASON)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

        #endif
            long dbg_mqlapi_trace_func_OrderGetInteger_datetime(ENUM_ORDER_PROPERTY_INTEGER property_id)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (datetime)::OrderGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_OrderGetInteger_datetime(ENUM_ORDER_PROPERTY_INTEGER property_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetInteger(property_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const datetime long_var = (datetime)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_OrderGetString(ENUM_ORDER_PROPERTY_STRING property_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetString(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_OrderGetString(ENUM_ORDER_PROPERTY_STRING property_id, string& string_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrderGetString(property_id, string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_OrdersTotal()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::OrdersTotal();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_PeriodSeconds(ENUM_TIMEFRAMES period = PERIOD_CURRENT)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, period, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PeriodSeconds(period);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PlaySound(string filename)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, filename, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlaySound(filename);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_PlotIndexGetInteger(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id)
            {
                switch(prop_id)
                {
                    case PLOT_DRAW_TYPE:        return(dbg_mqlapi_trace_func_PlotIndexGetInteger_ENUM_DRAW_TYPE(plot_index, prop_id));
                    case PLOT_LINE_STYLE:       return(dbg_mqlapi_trace_func_PlotIndexGetInteger_ENUM_LINE_STYLE(plot_index, prop_id));
                    case PLOT_LINE_COLOR:       return(dbg_mqlapi_trace_func_PlotIndexGetInteger_color(plot_index, prop_id));
                };
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, plot_index, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexGetInteger(plot_index, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_PlotIndexGetInteger(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_modifier)
            {
                switch(prop_id)
                {
                    case PLOT_DRAW_TYPE:        return(dbg_mqlapi_trace_func_PlotIndexGetInteger_ENUM_DRAW_TYPE(plot_index, prop_id, prop_modifier));
                    case PLOT_LINE_STYLE:       return(dbg_mqlapi_trace_func_PlotIndexGetInteger_ENUM_LINE_STYLE(plot_index, prop_id, prop_modifier));
                    case PLOT_LINE_COLOR:       return(dbg_mqlapi_trace_func_PlotIndexGetInteger_color(plot_index, prop_id, prop_modifier));
                };
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_modifier, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexGetInteger(plot_index, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_PlotIndexGetInteger_ENUM_DRAW_TYPE(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id)
            {
                ENUM_DRAW_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, plot_index, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_DRAW_TYPE)::PlotIndexGetInteger(plot_index, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((int)retval);
            };
            int dbg_mqlapi_trace_func_PlotIndexGetInteger_ENUM_DRAW_TYPE(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_modifier)
            {
                ENUM_DRAW_TYPE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_modifier, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_DRAW_TYPE)::PlotIndexGetInteger(plot_index, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((int)retval);
            };
            int dbg_mqlapi_trace_func_PlotIndexGetInteger_ENUM_LINE_STYLE(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id)
            {
                ENUM_LINE_STYLE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, plot_index, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_LINE_STYLE)::PlotIndexGetInteger(plot_index, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((int)retval);
            };
            int dbg_mqlapi_trace_func_PlotIndexGetInteger_ENUM_LINE_STYLE(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_modifier)
            {
                ENUM_LINE_STYLE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_modifier, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_LINE_STYLE)::PlotIndexGetInteger(plot_index, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((int)retval);
            };
            int dbg_mqlapi_trace_func_PlotIndexGetInteger_color(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id)
            {
                color retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, plot_index, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (color)::PlotIndexGetInteger(plot_index, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((int)retval);
            };
            int dbg_mqlapi_trace_func_PlotIndexGetInteger_color(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_modifier)
            {
                color retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_modifier, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (color)::PlotIndexGetInteger(plot_index, prop_id, prop_modifier);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((int)retval);
            };
            bool dbg_mqlapi_trace_func_PlotIndexSetDouble(int plot_index, ENUM_PLOT_PROPERTY_DOUBLE prop_id, double prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetDouble(plot_index, prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

            bool dbg_mqlapi_trace_func_PlotIndexSetInteger(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_value)
            {
                switch(prop_id)
                {
                    case PLOT_DRAW_TYPE:        return(dbg_mqlapi_trace_func_PlotIndexSetInteger_ENUM_DRAW_TYPE(plot_index, prop_id, (ENUM_DRAW_TYPE)prop_value));
                    case PLOT_LINE_STYLE:       return(dbg_mqlapi_trace_func_PlotIndexSetInteger_ENUM_LINE_STYLE(plot_index, prop_id, (ENUM_LINE_STYLE)prop_value));
                    case PLOT_LINE_COLOR:       return(dbg_mqlapi_trace_func_PlotIndexSetInteger_color(plot_index, prop_id, (color)prop_value));
                };
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetInteger(plot_index, prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PlotIndexSetInteger(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_modifier, int prop_value)
            {
                switch(prop_id)
                {
                    case PLOT_DRAW_TYPE:        return(dbg_mqlapi_trace_func_PlotIndexSetInteger_ENUM_DRAW_TYPE(plot_index, prop_id, prop_modifier, (ENUM_DRAW_TYPE)prop_value));
                    case PLOT_LINE_STYLE:       return(dbg_mqlapi_trace_func_PlotIndexSetInteger_ENUM_LINE_STYLE(plot_index, prop_id, prop_modifier, (ENUM_LINE_STYLE)prop_value));
                    case PLOT_LINE_COLOR:       return(dbg_mqlapi_trace_func_PlotIndexSetInteger_color(plot_index, prop_id, prop_modifier, (color)prop_value));
                };
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_modifier, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetInteger(plot_index, prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PlotIndexSetInteger_ENUM_DRAW_TYPE(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, ENUM_DRAW_TYPE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetInteger(plot_index, prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PlotIndexSetInteger_ENUM_DRAW_TYPE(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_DRAW_TYPE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_modifier, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetInteger(plot_index, prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PlotIndexSetInteger_ENUM_LINE_STYLE(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, ENUM_LINE_STYLE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetInteger(plot_index, prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PlotIndexSetInteger_ENUM_LINE_STYLE(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_modifier, ENUM_LINE_STYLE prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_modifier, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetInteger(plot_index, prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PlotIndexSetInteger_color(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, color prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetInteger(plot_index, prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PlotIndexSetInteger_color(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_modifier, color prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_modifier, prop_value, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetInteger(plot_index, prop_id, prop_modifier, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_PlotIndexSetString(int plot_index, ENUM_PLOT_PROPERTY_STRING prop_id, string prop_value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, plot_index, prop_id, prop_value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::PlotIndexSetString(plot_index, prop_id, prop_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_Point()
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::Point();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ResourceCreate(const string resource_name, const string path)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, resource_name, path, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ResourceCreate(resource_name, path);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ResourceCreate(const string resource_name, const uint& data[], uint img_width, uint img_height, uint data_xoffset, uint data_yoffset, uint data_width, ENUM_COLOR_FORMAT color_format)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, color_format, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, resource_name, data, img_width, img_height, data_xoffset, data_yoffset, data_width);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ResourceCreate(resource_name, data, img_width, img_height, data_xoffset, data_yoffset, data_width, color_format);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ResourceFree(const string resource_name)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, resource_name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ResourceFree(resource_name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ResourceReadImage(const string resource_name, uint& data[], uint& width, uint& height)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, resource_name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ResourceReadImage(resource_name, data, width, height);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(3, data, width, height, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ResourceReadImage(const string resource_name, uint& data[][], uint& width, uint& height)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, resource_name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ResourceReadImage(resource_name, data, width, height);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(3, data, width, height, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_ResourceSave(const string resource_name, const string file_name)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, resource_name, file_name, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ResourceSave(resource_name, file_name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SendFTP(string filename, string ftp_path = NULL)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, filename, ftp_path, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SendFTP(filename, ftp_path);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SendMail(string subject, string some_text)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, subject, some_text, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SendMail(subject, some_text);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SendNotification(string text)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, text, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SendNotification(text);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_SeriesInfoInteger(string symbol_name, ENUM_TIMEFRAMES timeframe, ENUM_SERIES_INFO_INTEGER prop_id)
            {
                switch(prop_id)
                {
                    case SERIES_FIRSTDATE:
                    case SERIES_LASTBAR_DATE:
                    case SERIES_SERVER_FIRSTDATE:
                    case SERIES_TERMINAL_FIRSTDATE:     return(dbg_mqlapi_trace_func_SeriesInfoInteger_datetime(symbol_name, timeframe, prop_id));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, timeframe, prop_id, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SeriesInfoInteger(symbol_name, timeframe, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SeriesInfoInteger(string symbol_name, ENUM_TIMEFRAMES timeframe, ENUM_SERIES_INFO_INTEGER prop_id, long& long_var)
            {
                switch(prop_id)
                {
                    case SERIES_FIRSTDATE:
                    case SERIES_LASTBAR_DATE:
                    case SERIES_SERVER_FIRSTDATE:
                    case SERIES_TERMINAL_FIRSTDATE:     return(dbg_mqlapi_trace_func_SeriesInfoInteger_datetime(symbol_name, timeframe, prop_id, long_var));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, timeframe, prop_id, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SeriesInfoInteger(symbol_name, timeframe, prop_id, long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_SeriesInfoInteger_datetime(string symbol_name, ENUM_TIMEFRAMES timeframe, ENUM_SERIES_INFO_INTEGER prop_id)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, timeframe, prop_id, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (datetime)::SeriesInfoInteger(symbol_name, timeframe, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool dbg_mqlapi_trace_func_SeriesInfoInteger_datetime(string symbol_name, ENUM_TIMEFRAMES timeframe, ENUM_SERIES_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, symbol_name, timeframe, prop_id, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SeriesInfoInteger(symbol_name, timeframe, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const datetime long_var = (datetime)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SetIndexBuffer(int index, double& buffer[], ENUM_INDEXBUFFER_TYPE data_type = INDICATOR_DATA)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, index, buffer, data_type, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SetIndexBuffer(index, buffer, data_type);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ShortArrayToString(const ushort& array[], int start = 0, int count = -1)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, array, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ShortArrayToString(array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_ShortToString(ushort symbol_code)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, symbol_code, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ShortToString(symbol_code);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_SignalBaseGetDouble(ENUM_SIGNAL_BASE_DOUBLE property_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalBaseGetDouble(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_SignalBaseGetInteger(ENUM_SIGNAL_BASE_INTEGER property_id)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalBaseGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_SignalBaseGetString(ENUM_SIGNAL_BASE_STRING property_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalBaseGetString(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SignalBaseSelect(int index)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, index, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalBaseSelect(index);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_SignalBaseTotal()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalBaseTotal();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_SignalInfoGetDouble(ENUM_SIGNAL_INFO_DOUBLE property_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalInfoGetDouble(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_SignalInfoGetInteger(ENUM_SIGNAL_INFO_INTEGER property_id)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalInfoGetInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_SignalInfoGetString(ENUM_SIGNAL_INFO_STRING property_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalInfoGetString(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SignalInfoSetDouble(ENUM_SIGNAL_INFO_DOUBLE property_id, double value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, property_id, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalInfoSetDouble(property_id, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SignalInfoSetInteger(ENUM_SIGNAL_INFO_INTEGER property_id, long value)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, property_id, value, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalInfoSetInteger(property_id, value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SignalSubscribe(long signal_id)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, signal_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalSubscribe(signal_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SignalUnsubscribe()
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SignalUnsubscribe();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_StringAdd(string& string_var, string add_substring)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, string_var, add_substring, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringAdd(string_var, add_substring);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            uint dbg_mqlapi_trace_func_StringBufferLen(string string_var)
            {
                uint retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringBufferLen(string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_StringCompare(const string& string1, const string& string2, bool case_sensitive = true)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, string1, string2, case_sensitive, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringCompare(string1, string2, case_sensitive);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_StringFill(string& string_var, ushort character)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, string_var, character, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringFill(string_var, character);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_StringFind(string string_value, string match_substring, int start_pos = 0)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, string_value, match_substring, start_pos, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringFind(string_value, match_substring, start_pos);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            ushort dbg_mqlapi_trace_func_StringGetCharacter(string string_value, int pos)
            {
                ushort retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, string_value, pos, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringGetCharacter(string_value, pos);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_StringInit(string& string_var, int new_len = 0, ushort character = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, new_len, character, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringInit(string_var, new_len, character);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_StringLen(string string_value)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, string_value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringLen(string_value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_StringReplace(string& str, const string find, const string replacement)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, str, find, replacement, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringReplace(str, find, replacement);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, str, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_StringSetCharacter(string& string_var, int pos, ushort character)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, string_var, pos, character, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringSetCharacter(string_var, pos, character);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_StringSplit(const string string_value, const ushort separator, string& result[])
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, string_value, separator, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringSplit(string_value, separator, result);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, result, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_StringSubstr(string string_value, int start_pos, int length = -1)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, string_value, start_pos, length, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringSubstr(string_value, start_pos, length);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_StringToCharArray(string text_string, uchar& array[], int start = 0, int count = -1, uint codepage = CP_ACP)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                string cp_name = NULL;
                switch(codepage)
                {
                    case CP_ACP:        cp_name = "CP_ACP";         break;
                    case CP_OEMCP:      cp_name = "CP_OEMCP";       break;
                    case CP_MACCP:      cp_name = "CP_MACCP";       break;
                    case CP_THREAD_ACP: cp_name = "CP_THREAD_ACP";  break;
                    case CP_SYMBOL:     cp_name = "CP_SYMBOL";      break;
                    case CP_UTF7:       cp_name = "CP_UTF7";        break;
                    case CP_UTF8:       cp_name = "CP_UTF8";        break;
                }
                if(cp_name == NULL)
                { DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, text_string, start, count, codepage, 0, 0, 0); }
                else
                { DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, text_string, start, count, codepage, cp_name, 0, 0); }
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringToCharArray(text_string, array, start, count, codepage);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            color dbg_mqlapi_trace_func_StringToColor(string color_string)
            {
                color retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, color_string, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringToColor(color_string);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_StringToDouble(string value)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringToDouble(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_StringToInteger(string value)
            {
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, value, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringToInteger(value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_StringToLower(string& string_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringToLower(string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_StringToShortArray(string text_string, ushort& array[], int start = 0, int count = -1)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, text_string, start, count, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringToShortArray(text_string, array, start, count);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, array, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_StringToTime(const string time_string)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, time_string, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringToTime(time_string);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_StringToUpper(string& string_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StringToUpper(string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_StructToTime(const MqlDateTime& dt_struct)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, dt_struct, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::StructToTime(dt_struct);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_Symbol()
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::Symbol();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_SymbolInfoDouble(string name, ENUM_SYMBOL_INFO_DOUBLE prop_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoDouble(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolInfoDouble(string name, ENUM_SYMBOL_INFO_DOUBLE prop_id, double& double_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoDouble(name, prop_id, double_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, double_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long dbg_mqlapi_trace_func_SymbolInfoInteger(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                switch(prop_id)
                {
                #ifndef __MQL4__
                    case SYMBOL_SECTOR:                     return(__SymbolInfoInteger_ENUM_SYMBOL_SECTOR(name, prop_id));
                    case SYMBOL_INDUSTRY:                   return(__SymbolInfoInteger_ENUM_SYMBOL_INDUSTRY(name, prop_id));
                    case SYMBOL_CHART_MODE:                 return(__SymbolInfoInteger_ENUM_SYMBOL_CHART_MODE(name, prop_id));
                    case SYMBOL_ORDER_GTC_MODE:             return(__SymbolInfoInteger_ENUM_SYMBOL_ORDER_GTC_MODE(name, prop_id));
                    case SYMBOL_OPTION_MODE:                return(__SymbolInfoInteger_ENUM_SYMBOL_OPTION_MODE(name, prop_id));
                    case SYMBOL_OPTION_RIGHT:               return(__SymbolInfoInteger_ENUM_SYMBOL_OPTION_RIGHT(name, prop_id));
                    case SYMBOL_BACKGROUND_COLOR:           return(__SymbolInfoInteger_color(name, prop_id));
                    case SYMBOL_TRADE_CALC_MODE:            return(__SymbolInfoInteger_ENUM_SYMBOL_CALC_MODE(name, prop_id));
                    case SYMBOL_SWAP_MODE:                  return(__SymbolInfoInteger_ENUM_SYMBOL_SWAP_MODE(name, prop_id));

                #endif
                    case SYMBOL_TRADE_MODE:                 return(__SymbolInfoInteger_ENUM_SYMBOL_TRADE_MODE(name, prop_id));
                    case SYMBOL_TRADE_EXEMODE:              return(__SymbolInfoInteger_ENUM_SYMBOL_TRADE_EXECUTION(name, prop_id));
                    case SYMBOL_SWAP_ROLLOVER3DAYS:         return(__SymbolInfoInteger_ENUM_DAY_OF_WEEK(name, prop_id));
                    case SYMBOL_TIME:
                    case SYMBOL_START_TIME:
                    case SYMBOL_EXPIRATION_TIME:            return(__SymbolInfoInteger_datetime(name, prop_id));
                }
                long retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolInfoInteger(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& long_var)
            {
                switch(prop_id)
                {
                #ifndef __MQL4__
                    case SYMBOL_SECTOR:                     return(__SymbolInfoInteger_ENUM_SYMBOL_SECTOR(name, prop_id, long_var));
                    case SYMBOL_INDUSTRY:                   return(__SymbolInfoInteger_ENUM_SYMBOL_INDUSTRY(name, prop_id, long_var));
                    case SYMBOL_CHART_MODE:                 return(__SymbolInfoInteger_ENUM_SYMBOL_CHART_MODE(name, prop_id, long_var));
                    case SYMBOL_ORDER_GTC_MODE:             return(__SymbolInfoInteger_ENUM_SYMBOL_ORDER_GTC_MODE(name, prop_id, long_var));
                    case SYMBOL_OPTION_MODE:                return(__SymbolInfoInteger_ENUM_SYMBOL_OPTION_MODE(name, prop_id, long_var));
                    case SYMBOL_OPTION_RIGHT:               return(__SymbolInfoInteger_ENUM_SYMBOL_OPTION_RIGHT(name, prop_id, long_var));
                    case SYMBOL_BACKGROUND_COLOR:           return(__SymbolInfoInteger_color(name, prop_id, long_var));
                    case SYMBOL_TRADE_CALC_MODE:            return(__SymbolInfoInteger_ENUM_SYMBOL_CALC_MODE(name, prop_id, long_var));
                    case SYMBOL_SWAP_MODE:                  return(__SymbolInfoInteger_ENUM_SYMBOL_SWAP_MODE(name, prop_id, long_var));

                #endif
                    case SYMBOL_TRADE_MODE:                 return(__SymbolInfoInteger_ENUM_SYMBOL_TRADE_MODE(name, prop_id, long_var));
                    case SYMBOL_TRADE_EXEMODE:              return(__SymbolInfoInteger_ENUM_SYMBOL_TRADE_EXECUTION(name, prop_id, long_var));
                    case SYMBOL_SWAP_ROLLOVER3DAYS:         return(__SymbolInfoInteger_ENUM_DAY_OF_WEEK(name, prop_id, long_var));
                    case SYMBOL_TIME:
                    case SYMBOL_START_TIME:
                    case SYMBOL_EXPIRATION_TIME:            return(__SymbolInfoInteger_datetime(name, prop_id, long_var));
                }
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
        #ifndef __MQL4__
            long __SymbolInfoInteger_ENUM_SYMBOL_SECTOR(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_SECTOR retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_SECTOR)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_SECTOR(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_SECTOR long_var = (ENUM_SYMBOL_SECTOR)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long __SymbolInfoInteger_ENUM_SYMBOL_INDUSTRY(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_INDUSTRY retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_INDUSTRY)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_INDUSTRY(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_INDUSTRY long_var = (ENUM_SYMBOL_INDUSTRY)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long __SymbolInfoInteger_ENUM_SYMBOL_CHART_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_CHART_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_CHART_MODE)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_CHART_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_CHART_MODE long_var = (ENUM_SYMBOL_CHART_MODE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long __SymbolInfoInteger_ENUM_SYMBOL_CALC_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_CALC_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_CALC_MODE)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_CALC_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_CALC_MODE long_var = (ENUM_SYMBOL_CALC_MODE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

        #endif
            long __SymbolInfoInteger_ENUM_SYMBOL_TRADE_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_TRADE_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_TRADE_MODE)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_TRADE_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_TRADE_MODE long_var = (ENUM_SYMBOL_TRADE_MODE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long __SymbolInfoInteger_ENUM_SYMBOL_TRADE_EXECUTION(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_TRADE_EXECUTION retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_TRADE_EXECUTION)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_TRADE_EXECUTION(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_TRADE_EXECUTION long_var = (ENUM_SYMBOL_TRADE_EXECUTION)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
        #ifndef __MQL4__
            long __SymbolInfoInteger_ENUM_SYMBOL_SWAP_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_SWAP_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_SWAP_MODE)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_SWAP_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_SWAP_MODE long_var = (ENUM_SYMBOL_SWAP_MODE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

        #endif
            long __SymbolInfoInteger_ENUM_DAY_OF_WEEK(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_DAY_OF_WEEK retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_DAY_OF_WEEK)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_DAY_OF_WEEK(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_DAY_OF_WEEK long_var = (ENUM_DAY_OF_WEEK)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
        #ifndef __MQL4__
            long __SymbolInfoInteger_ENUM_SYMBOL_ORDER_GTC_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_ORDER_GTC_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_ORDER_GTC_MODE)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_ORDER_GTC_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_ORDER_GTC_MODE long_var = (ENUM_SYMBOL_ORDER_GTC_MODE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long __SymbolInfoInteger_ENUM_SYMBOL_OPTION_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_OPTION_MODE retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_OPTION_MODE)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_OPTION_MODE(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_OPTION_MODE long_var = (ENUM_SYMBOL_OPTION_MODE)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long __SymbolInfoInteger_ENUM_SYMBOL_OPTION_RIGHT(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                ENUM_SYMBOL_OPTION_RIGHT retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (ENUM_SYMBOL_OPTION_RIGHT)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_ENUM_SYMBOL_OPTION_RIGHT(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const ENUM_SYMBOL_OPTION_RIGHT long_var = (ENUM_SYMBOL_OPTION_RIGHT)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };

        #endif
            long __SymbolInfoInteger_color(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                color retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (color)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_color(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const color long_var = (color)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            long __SymbolInfoInteger_datetime(string name, ENUM_SYMBOL_INFO_INTEGER prop_id)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = (datetime)::SymbolInfoInteger(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return((long)retval);
            };
            bool __SymbolInfoInteger_datetime(string name, ENUM_SYMBOL_INFO_INTEGER prop_id, long& _long_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoInteger(name, prop_id, _long_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                const datetime long_var = (datetime)_long_var;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, long_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolInfoSessionQuote(string name, ENUM_DAY_OF_WEEK day_of_week, uint session_index, datetime& from, datetime& to)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, name, day_of_week, session_index, from, to, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoSessionQuote(name, day_of_week, session_index, from, to);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, from, to, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolInfoSessionTrade(string name, ENUM_DAY_OF_WEEK day_of_week, uint session_index, datetime& from, datetime& to)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, name, day_of_week, session_index, from, to, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoSessionTrade(name, day_of_week, session_index, from, to);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, from, to, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_SymbolInfoString(string name, ENUM_SYMBOL_INFO_STRING prop_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoString(name, prop_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolInfoString(string name, ENUM_SYMBOL_INFO_STRING prop_id, string& string_var)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, prop_id, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoString(name, prop_id, string_var);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, string_var, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolInfoTick(string symbol, MqlTick& tick)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, symbol, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolInfoTick(symbol, tick);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, tick, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolIsSynchronized(string name)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, name, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolIsSynchronized(name);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_SymbolName(int pos, bool selected)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, pos, selected, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolName(pos, selected);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_SymbolSelect(string name, bool select)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, name, select, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolSelect(name, select);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_SymbolsTotal(bool selected)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, selected, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::SymbolsTotal(selected);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_TerminalClose(int ret_code)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, ret_code, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TerminalClose(ret_code);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_TerminalInfoDouble(ENUM_TERMINAL_INFO_DOUBLE property_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TerminalInfoDouble(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TerminalInfoInteger(ENUM_TERMINAL_INFO_INTEGER property_id)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TerminalInfoInteger(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_TerminalInfoString(ENUM_TERMINAL_INFO_STRING property_id)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, property_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TerminalInfoString(property_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            double dbg_mqlapi_trace_func_TesterStatistics(ENUM_STATISTICS statistic_id)
            {
                double retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, statistic_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TesterStatistics(statistic_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_TextGetSize(const string text, uint& width, uint& height)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, text, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TextGetSize(text, width, height);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, width, height, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_TextOut(const string text, int x, int y, uint anchor, uint& data[], uint width, uint height, uint _color, ENUM_COLOR_FORMAT color_format)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, _color, color_format, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, text, x, y, anchor, data, width, height);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TextOut(text, x, y, anchor, data, width, height, _color, color_format);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_TextSetFont(const string name, int size, uint flags, int orientation = 0)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _FONT_ITALIC                 = ((flags & FONT_ITALIC) != NULL);
                const bool _FONT_UNDERLINE              = ((flags & FONT_UNDERLINE) != NULL);
                const bool _FONT_STRIKEOUT              = ((flags & FONT_STRIKEOUT) != NULL);
                const bool _FW_DONTCARE                 = ((flags & FW_DONTCARE) != NULL);
                const bool _FW_THIN                     = ((flags & FW_THIN) != NULL);
                const bool _FW_EXTRALIGHT               = ((flags & FW_EXTRALIGHT) != NULL);
                const bool _FW_ULTRALIGHT               = ((flags & FW_ULTRALIGHT) != NULL);
                const bool _FW_LIGHT                    = ((flags & FW_LIGHT) != NULL);
                const bool _FW_NORMAL                   = ((flags & FW_NORMAL) != NULL);
                const bool _FW_REGULAR                  = ((flags & FW_REGULAR) != NULL);
                const bool _FW_MEDIUM                   = ((flags & FW_MEDIUM) != NULL);
                const bool _FW_SEMIBOLD                 = ((flags & FW_SEMIBOLD) != NULL);
                const bool _FW_DEMIBOLD                 = ((flags & FW_DEMIBOLD) != NULL);
                const bool _FW_BOLD                     = ((flags & FW_BOLD) != NULL);
                const bool _FW_EXTRABOLD                = ((flags & FW_EXTRABOLD) != NULL);
                const bool _FW_ULTRABOLD                = ((flags & FW_ULTRABOLD) != NULL);
                const bool _FW_HEAVY                    = ((flags & FW_HEAVY) != NULL);
                const bool _FW_BLACK                    = ((flags & FW_BLACK) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, _FW_BLACK, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, _FW_MEDIUM, _FW_SEMIBOLD, _FW_DEMIBOLD, _FW_BOLD, _FW_EXTRABOLD, _FW_ULTRABOLD, _FW_HEAVY);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, _FW_DONTCARE, _FW_THIN, _FW_EXTRALIGHT, _FW_ULTRALIGHT, _FW_LIGHT, _FW_NORMAL, _FW_REGULAR);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, name, size, flags, orientation, _FONT_ITALIC, _FONT_UNDERLINE, _FONT_STRIKEOUT);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TextSetFont(name, size, flags, orientation);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_TimeCurrent()
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeCurrent();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_TimeCurrent(MqlDateTime& dt_struct)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeCurrent(dt_struct);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dt_struct, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeDaylightSavings()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeDaylightSavings();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_TimeGMT()
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeGMT();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_TimeGMT(MqlDateTime& dt_struct)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeGMT(dt_struct);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dt_struct, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_TimeGMTOffset()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeGMTOffset();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_TimeLocal()
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeLocal();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            datetime dbg_mqlapi_trace_func_TimeLocal(MqlDateTime& dt_struct)
            {
                datetime retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeLocal(dt_struct);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dt_struct, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            string dbg_mqlapi_trace_func_TimeToString(datetime value, int mode = TIME_DATE | TIME_MINUTES)
            {
                string retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                const bool _TIME_DATE       = ((mode & TIME_DATE) != NULL);
                const bool _TIME_MINUTES    = ((mode & TIME_MINUTES) != NULL);
                const bool _TIME_SECONDS    = ((mode & TIME_SECONDS) != NULL);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, value, mode, _TIME_DATE, _TIME_MINUTES, _TIME_SECONDS, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeToString(value, mode);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            bool dbg_mqlapi_trace_func_TimeToStruct(datetime dt, MqlDateTime& dt_struct)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TimeToStruct(dt, dt_struct);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, dt_struct, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            short dbg_mqlapi_trace_func_TranslateKey(int key_code)
            {
                bool retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, key_code, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::TranslateKey(key_code);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_UninitializeReason()
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::UninitializeReason();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WebRequest(const string method, const string url, const string cookie, const string referer, int timeout, const char& data[], int data_size, char& result[], string& result_headers)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(7, method, url, cookie, referer, timeout, data, data_size);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::WebRequest(method, url, cookie, referer, timeout, data, data_size, result, result_headers);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, result, result_headers, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_WebRequest(const string method, const string url, const string headers, int timeout, const char& data[], char& result[], string& result_headers)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(5, method, url, headers, timeout, data, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::WebRequest(method, url, headers, timeout, data, result, result_headers);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(2, result, result_headers, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };


            // ObjectCreate rewrite function

            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, time02, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time02, price02, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, time02, price02, time03, price03, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time05, price05, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, time05, price05, time06, price06, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time08, price08, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, time08, price08, time09, price09, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time11, price11, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, time11, price11, time12, price12, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time14, price14, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, time14, price14, time15, price15, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time17, price17, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, time17, price17, time18, price18, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time20, price20, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20, datetime time21, double price21)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, time20, price20, time21, price21, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20, time21, price21);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20, datetime time21, double price21,
                    datetime time22, double price22)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time20, price20, time21, price21, time22, price22, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20, time21, price21,
                                      time22, price22);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20, datetime time21, double price21,
                    datetime time22, double price22, datetime time23, double price23)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time23, price23, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time20, price20, time21, price21, time22, price22, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20, time21, price21,
                                      time22, price22, time23, price23);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20, datetime time21, double price21,
                    datetime time22, double price22, datetime time23, double price23, datetime time24, double price24)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, time23, price23, time24, price24, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time20, price20, time21, price21, time22, price22, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20, time21, price21,
                                      time22, price22, time23, price23, time24, price24);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20, datetime time21, double price21,
                    datetime time22, double price22, datetime time23, double price23, datetime time24, double price24,
                    datetime time25, double price25)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time23, price23, time24, price24, time25, price25, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time20, price20, time21, price21, time22, price22, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20, time21, price21,
                                      time22, price22, time23, price23, time24, price24,
                                      time25, price25);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20, datetime time21, double price21,
                    datetime time22, double price22, datetime time23, double price23, datetime time24, double price24,
                    datetime time25, double price25, datetime time26, double price26)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time26, price26, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time23, price23, time24, price24, time25, price25, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time20, price20, time21, price21, time22, price22, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20, time21, price21,
                                      time22, price22, time23, price23, time24, price24,
                                      time25, price25, time26, price26);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20, datetime time21, double price21,
                    datetime time22, double price22, datetime time23, double price23, datetime time24, double price24,
                    datetime time25, double price25, datetime time26, double price26, datetime time27, double price27)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(4, time26, price26, time27, price27, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time23, price23, time24, price24, time25, price25, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time20, price20, time21, price21, time22, price22, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20, time21, price21,
                                      time22, price22, time23, price23, time24, price24,
                                      time25, price25, time26, price26, time27, price27);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20, datetime time21, double price21,
                    datetime time22, double price22, datetime time23, double price23, datetime time24, double price24,
                    datetime time25, double price25, datetime time26, double price26, datetime time27, double price27,
                    datetime time28, double price28)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time26, price26, time27, price27, time28, price28, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time23, price23, time24, price24, time25, price25, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time20, price20, time21, price21, time22, price22, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20, time21, price21,
                                      time22, price22, time23, price23, time24, price24,
                                      time25, price25, time26, price26, time27, price27,
                                      time28, price28);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };
            int dbg_mqlapi_trace_func_ObjectCreate(long chart_id, string name, ENUM_OBJECT type, int sub_window, datetime time01, double price01, datetime time02, double price02, datetime time03, double price03,
                    datetime time04, double price04, datetime time05, double price05, datetime time06, double price06,
                    datetime time07, double price07, datetime time08, double price08, datetime time09, double price09,
                    datetime time10, double price10, datetime time11, double price11, datetime time12, double price12,
                    datetime time13, double price13, datetime time14, double price14, datetime time15, double price15,
                    datetime time16, double price16, datetime time17, double price17, datetime time18, double price18,
                    datetime time19, double price19, datetime time20, double price20, datetime time21, double price21,
                    datetime time22, double price22, datetime time23, double price23, datetime time24, double price24,
                    datetime time25, double price25, datetime time26, double price26, datetime time27, double price27,
                    datetime time28, double price28, datetime time29, double price29)
            {
                int retval;
                _global_trace_data[tracer_call_stack_depth]._return_type = typename((retval));
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(2, time29, price29, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time26, price26, time27, price27, time28, price28, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time23, price23, time24, price24, time25, price25, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time20, price20, time21, price21, time22, price22, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time17, price17, time18, price18, time19, price19, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time14, price14, time15, price15, time16, price16, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time11, price11, time12, price12, time13, price13, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time08, price08, time09, price09, time10, price10, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time05, price05, time06, price06, time07, price07, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, time02, price02, time03, price03, time04, price04, 0);
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(6, chart_id, name, type, sub_window, time01, price01, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                retval = ::ObjectCreate(chart_id, name, type, sub_window, time01, price01, time02, price02, time03, price03,
                                      time04, price04, time05, price05, time06, price06,
                                      time07, price07, time08, price08, time09, price09,
                                      time10, price10, time11, price11, time12, price12,
                                      time13, price13, time14, price14, time15, price15,
                                      time16, price16, time17, price17, time18, price18,
                                      time19, price19, time20, price20, time21, price21,
                                      time22, price22, time23, price23, time24, price24,
                                      time25, price25, time26, price26, time27, price27,
                                      time28, price28, time29, price29);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return(retval);
            };


            // MQL-API void-typed function rewrite

            template <typename T>   void dbg_mqlapi_trace_func_ArrayFree(T& arr[])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFree(arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ArrayFree(T& arr[][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFree(arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ArrayFree(T& arr[][][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFree(arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ArrayFree(T& arr[][][][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFree(arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ArrayFree(T*& arr[])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFree(arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ArrayFree(T*& arr[][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFree(arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ArrayFree(T*& arr[][][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFree(arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ArrayFree(T*& arr[][][][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFree(arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T,
                      typename U> void dbg_mqlapi_trace_func_ArrayFill(T& arr[], const int offset, const int count, const U value)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, offset, count, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFill(arr, offset, count, (T)value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T,
                      typename U> void dbg_mqlapi_trace_func_ArrayFill(T& arr[][], const int offset, const int count, const U value)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, offset, count, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFill(arr, offset, count, (T)value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T,
                      typename U> void dbg_mqlapi_trace_func_ArrayFill(T& arr[][][], const int offset, const int count, const U value)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, offset, count, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFill(arr, offset, count, (T)value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T,
                      typename U> void dbg_mqlapi_trace_func_ArrayFill(T& arr[][][][], const int offset, const int count, const U value)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(3, offset, count, value, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ArrayFill(arr, offset, count, (T)value);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ZeroMemory(T& variable)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ZeroMemory(variable);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, variable, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ZeroMemory(T& var_arr[])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ZeroMemory(var_arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, var_arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ZeroMemory(T& var_arr[][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ZeroMemory(var_arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, var_arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ZeroMemory(T& var_arr[][][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ZeroMemory(var_arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, var_arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ZeroMemory(T& var_arr[][][][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ZeroMemory(var_arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, var_arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ZeroMemory(T*& var_arr[])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ZeroMemory(var_arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, var_arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ZeroMemory(T*& var_arr[][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ZeroMemory(var_arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, var_arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ZeroMemory(T*& var_arr[][][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ZeroMemory(var_arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, var_arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            template <typename T>   void dbg_mqlapi_trace_func_ZeroMemory(T*& var_arr[][][][])
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ZeroMemory(var_arr);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNC_PARAM_RESULTS_STR(1, var_arr, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_ChartRedraw(const long chart_id = 0)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, chart_id, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ChartRedraw(chart_id);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_DebugBreak()
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DebugBreak();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_EventKillTimer()
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                EventKillTimer();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_ExpertRemove()
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ExpertRemove();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_FileClose(const int file_handle)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                FileClose(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_FileFindClose(const int search_handle)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, search_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                FileFindClose(search_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_FileFlush(const int file_handle)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, file_handle, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                FileFlush(file_handle);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_GlobalVariablesFlush()
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                GlobalVariablesFlush();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_MathSrand(const int seed)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, seed, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                MathSrand(seed);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_ResetLastError()
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                ResetLastError();
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_SetUserError(ushort user_error)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, user_error, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                SetUserError(user_error);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_Sleep(const int milliseconds)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, milliseconds, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                Sleep(milliseconds);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };
            void dbg_mqlapi_trace_func_srand(const int seed)
            {
                string retval = "NV";
                _global_trace_data[tracer_call_stack_depth]._return_type = "void";
                DBG_MQLAPI_TRACE_FUNCTION_CALL_SETUP;
                DBG_MQLAPI_TRACE_FUNC_PARAMS_STR(1, seed, 0, 0, 0, 0, 0, 0);
                DBG_MQLAPI_TRACE_FUNC_BEFORE;
                srand(seed);
                DBG_MQLAPI_TRACE_FUNC_AFTER;
                DBG_MQLAPI_TRACE_FUNCTION_CALL_FINALIZE;
                return;
            };

    };


#ifndef __MQL4__
    };

#endif

//
/////////////////////////////////////////////////////////////////////////////////////////////////////


//
// END Debugging support
//*********************************************************************************************************************************************************/
#endif // LIB_DBG_DEBUG_MQLAPI_MQL45_TRACER_MQH_INCLUDED
